package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.Box;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class SaveCodingSchemePanel extends JPanel implements ItemListener {
	private JLabel fileNameLbl = new JLabel("File name: ");

	private JTextField csNameTxt = new JTextField(15);

	private JTextField fileNameTxt = new JTextField(15);

	private JCheckBox saveAsXml = new JCheckBox(
			"Save Coding Scheme as an XML file");

	public SaveCodingSchemePanel(String csName, String csFileName) {
		this.csNameTxt.setText(csName);
		this.fileNameTxt.setText(csFileName);
		
		fileNameLbl.setEnabled(false);
		fileNameTxt.setEditable(false);
		saveAsXml.addItemListener(this);

		JPanel centerPanel = getCenterPanel();

		setLayout(new BorderLayout());
		add(centerPanel, BorderLayout.CENTER);
	}

	private JPanel getCenterPanel() {
		saveAsXml.setToolTipText("Possible to reuse with other databases");

		JPanel panel = new JPanel();
		GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();

		panel.setLayout(gbl);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = 1;
		gbc.insets = new Insets(0, 0, 0, 0);
		panel.add(new JLabel("Coding Scheme name: "), gbc);

		panel.add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		panel.add(csNameTxt, gbc);

		gbc.anchor = GridBagConstraints.NORTHWEST;
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		panel.add(saveAsXml, gbc);

		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = 1;
		gbc.insets = new Insets(0, 0, 0, 0);
		panel.add(fileNameLbl, gbc);

		panel.add(Box.createHorizontalStrut(10));
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		panel.add(fileNameTxt, gbc);

		return panel;
	}

	@Override
	public void itemStateChanged(ItemEvent event) {
		if (saveAsXml.isSelected()) {
			fileNameLbl.setEnabled(true);
			fileNameTxt.setEditable(true);
		} else {
			fileNameLbl.setEnabled(false);
			fileNameTxt.setEditable(false);
		}
	}

	public String getCodingSchemeName() {
		return csNameTxt.getText();
	}

	public String getFileName() {
		if (saveAsXml.isSelected())
			return fileNameTxt.getText();
		return null;
	}
}
