package edu.bu.signstream.common.util.https.responses;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * This class is used to store the invalid JSON response from an HTTP request.
 * To be clear, the JSON response passed into this class is valid, but modified to not throw an error and be valid...
 * All invalid JSON strings will look like this:
 * {
 *     "data": <invalid JSON String>
 * }
 *
 * The outer JSON will always be valid, but the inner data JSON string will hold an invalid JSON string.
 */
public class InvalidJSONResponse {
    @JsonProperty("data")
    private String data;

    public String getData() {
        return this.data;
    }
}
