package edu.bu.signstream.common.util.vo.ss3.db;

import java.util.*;

public class SS3ElementCollection {

   private HashMap<String, Object> objects = new HashMap<String, Object>();

   public SS3ElementCollection(HashMap<String, Object> objects) {
      this.objects = objects;
   }

   public SS3ElementCollection() {}

   public void removeAll() {
      Set<String> set = objects.keySet();
      Iterator<String> iter = set.iterator();
      while (iter.hasNext()) {
         Object key = iter.next();
         objects.remove(key);
      }
   }

   public void addElement(SS3Element element) {
	   objects.put(element.getId(), element);
   }
   
   public void removeElement(SS3Element element) {
	   if (element == null)
		   return;
	   
	   objects.remove(element.getId());
   }

   public ArrayList<Object> getObjectsList() {
      ArrayList<Object> list = new ArrayList<Object>();
      Set<String> set = objects.keySet();
      Iterator<String> iter = set.iterator();
      while (iter.hasNext()) {
         Object key = iter.next();
         list.add(objects.get(key));
      }
      return list;
   }

   public int size() {
      return objects.size();
   }
   
   public Object getElementWithID(String id) {
	   return objects.get(id);
   }

   public SS3Element getElement(String elementID) {
//	   //
//	   Set set  = objects.keySet();
//	   Iterator it = set.iterator();
//	   while(it.hasNext()) {
//		   Object key = it.next();
//		   System.out.println("key = " + key);
//	   }
//	   
//	   Object obj = objects.get(elementID);
//	   System.out.println("size  = " + objects.size() + "getElement = " + obj);
//	   //
      return (SS3Element) objects.get(elementID);
   }
   
   public void updateElement(SS3Element element) {
      addElement(element);
   }
   
   @Override
public String toString() {
	   StringBuffer sb = new StringBuffer("SS3ElementCollection: ");

	   Set<String> set  = objects.keySet();
	   Iterator<String> it = set.iterator();
	   while(it.hasNext()) {
		   Object key = it.next();
		   sb.append("\n key = ");
		   sb.append(key);
	   }
	   
	   return sb.toString();
   }
}
