package edu.bu.signstream.common.util.vo.ss3.note;

import java.util.*;

import javax.swing.JCheckBox;
import javax.swing.JTextArea;

public class SS3Note {
   private String ID = "";
   private String coderID = "";
   private String timeCreated = "";
   private String timeUpdated = "";
   private String subject = "";
   private String body = "";
   
   private JTextArea text = null;
   private JCheckBox checkBox = new JCheckBox();
   
   public SS3Note() {
	   this.text = new JTextArea(body);
   }
   
   public JTextArea getTextArea() {
	   return text;
   }
   
   public JCheckBox getCheckBox() {
	   return checkBox;
   }

   public Calendar getCreatedCalendar() {
      if (timeCreated != null && timeCreated.length() > 0) {
         Calendar calendar = new GregorianCalendar();
         long time = Long.parseLong(timeCreated);
         calendar.setTimeInMillis(time);
         return calendar;
      } else {
         // return current time
         return Calendar.getInstance();
      }
   }
   
   public void setCurrentTime() {
	   Calendar c = Calendar.getInstance();
	   timeCreated = "" + c.getTimeInMillis();
   }
   
   public String getDayNTimeCreated() {
	      Calendar c = getCreatedCalendar();
	      StringBuffer sb = new StringBuffer();
	      sb.append(c.get(Calendar.MONTH)+1);
	      sb.append("/");
	      sb.append(c.get(Calendar.DAY_OF_MONTH));
	      sb.append("/");
	      sb.append(c.get(Calendar.YEAR));
	      sb.append(" ");
	      sb.append(c.get(Calendar.HOUR_OF_DAY));
	      sb.append(":");
	      sb.append(c.get(Calendar.MINUTE));
	      int am = c.get(Calendar.AM_PM);
	      if (am == 0) {
	         sb.append(" AM");
	      } else {
	         sb.append(" PM");
	      }
	      return sb.toString();
   }
   
   public String getSubjectAndBody() {
      return subject + ": " + body;
   }

   public String getBody() {
      return body;
   }

   public String getID() {
      return ID;
   }

   public String getSubject() {
      return subject;
   }

   public void setBody(String string) {
      body = string;
   }

   public void setID(String string) {
      ID = string;
   }

   public void setSubject(String string) {
      subject = string;
   }

   public String getCoderID() {
      return coderID;
   }

   public String getTimeCreated() {
      return timeCreated;
   }

   public String getTimeUpdated() {
      return timeUpdated;
   }

   public void setCoderID(String string) {
      coderID = string;
   }

   public void setTimeCreated(String string) {
      timeCreated = string;
   }

   public void setTimeUpdated(String string) {
      timeUpdated = string;
   }
}