package edu.bu.signstream.grepresentation.fields.customField;

import edu.bu.signstream.common.util.vo.ss3.db.SS3Track;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntityCollection;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualField;
import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

import java.util.ArrayList;

public class CustomPointField extends NonManualField {

	public CustomPointField(SS3Track ss3track, SignStreamSegmentPanel segmentPanel, PresentationField parentField) {
		super(ss3track, segmentPanel, parentField);	// this creates the track entity
	}
	

	@Override
	protected void createTrackEntity(SS3Track track) {
        var chainedEvents = new ArrayList<ChainedEventsEntity>();

        for (var e : track.getEntities()) {
            var item = e.getItems().get(0);

            var collection = new CustomChainedEventsCollection();
            collection.setValueEvent(new ChainedEvent(item, segmentPanel));

            var entity = new CustomPointChainedEventsEntity(collection, segmentPanel, this);
            if (e.getParentEntityIDs() == null || e.getParentEntityIDs().isEmpty()) {
            	entity.updateParentEntity();
            } else {
            	entity.setParentEntities(getParentField().getEntities(e.getParentEntityIDs()));
            }
            entity.setID(e.getID());
            entity.setField(this);
            entity.setRefEntityId(e.getRefEntityId());

            chainedEvents.add(entity);
        }

        collection = new ChainedEventsEntityCollection(chainedEvents, segmentPanel);
	}

}
