package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JDialog;

import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;

import edu.bu.signstream.grepresentation.listener.WeakWindowListener;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;

import edu.bu.signstream.grepresentation.view.GestureNRelatedView;

import edu.bu.signstream.ui.ConfirmationDialog;
import edu.bu.signstream.ui.SignStreamDialogInterface;


public class GestureInfoDialog extends JDialog implements
		WindowListener, SignStreamDialogInterface {

	private static final long serialVersionUID = 1L;

	private GestureInfoPanel panel = null;

	public GestureInfoDialog(GestureFieldWrapper wrapper, GestureNRelatedView view) {
		super(SS3Singleton.getSignStreamApplication(), "Gesture Info");
		super.setLocationRelativeTo(SS3Singleton.getSignStreamApplication());
		
		panel = new GestureInfoPanel(wrapper, view, this);

		addWindowListener(new WeakWindowListener(this, this));

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(150, 150));
		contentPane.add(panel, BorderLayout.CENTER);

		this.pack();		
	}
	
	public void update(GestureFieldWrapper wrapper, GestureNRelatedView view) {
		panel.update(wrapper, view);
	}

	@Override
	public void windowClosing(WindowEvent e) {
		boolean isChanged = this.panel.isChanged();

		if (isChanged) {
	        ConfirmationDialog dialog = new ConfirmationDialog(this);
	        dialog.setLocationRelativeTo(this);
	        dialog.setModal(true);
	        dialog.setVisible(true);
		} else {
			this.setVisible(false);
		}
	}

	@Override
	public boolean saveChanges() {
		return panel.updateChanges();
	}

	@Override
	public void discardChanges() {
		dispose();
		setVisible(false);
	}

    @Override
    public void dispose() {
        super.dispose();
    }

	@Override
	public void windowClosed(WindowEvent e) {
		// This will only be seen on standard output.
		// displayMessage("WindowListener method called: windowClosed.");
	}

	@Override
	public void windowOpened(WindowEvent e) {
		// displayMessage("WindowListener method called: windowOpened.");
	}

	@Override
	public void windowIconified(WindowEvent e) {
		// displayMessage("WindowListener method called: windowIconified.");
	}

	@Override
	public void windowDeiconified(WindowEvent e) {
		// displayMessage("WindowListener method called: windowDeiconified.");
	}

	@Override
	public void windowActivated(WindowEvent e) {
		// displayMessage("WindowListener method called: windowActivated.");
	}

	@Override
	public void windowDeactivated(WindowEvent e) {
		// displayMessage("WindowListener method called: windowDeactivated.");
	}

	public GestureEventsEntity getCurrentGestureEntity() {
		return panel.getCurrentGestureEntity();
	}

	public GestureInfoPanel getGestureInfoPanel() {
		return panel;
	}
}
