package edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.locationField.GestureLocationEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.gesturePropertyField.GesturePropertyEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class AddGestureRelaxedActionListener implements ActionListener {

   private GestureChainedEventsEntity selectedEntity = null;

   public void setSelectedEntity(GestureChainedEventsEntity entity) {
	   this.selectedEntity = entity;
   }
   
   @Override
public void actionPerformed(ActionEvent e) {
//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton
				.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time minRelaxedStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getFollowingFrameTimeInfo(
//						selectedEntity.getEndTimeInfo());

//		if (minRelaxedStartTimeInfo.greaterThan(utterance.getEndTimeInfo())) {
//			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//		} 
			
		GestureChainedEventsEntity nextEntity = selectedEntity.getNextEntity();
		
		if(nextEntity != null) {
			Time nextEntiyStartTimeInfo = nextEntity.getStartTimeInfo();
//			int frameDuration =  (int)segmentPanel.getMultipleMovieController().getPacketDuration();
			Time maxRelaxedTimeInfo = segmentPanel.getMultipleMovieController().getPrecedingFrameTimeInfo(nextEntiyStartTimeInfo);
			if(selectedEntity.getEndTimeInfo().greaterThan(maxRelaxedTimeInfo)) {
				SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
				return;
			}
		}
		
		String seWarning = selectedEntity.addRelaxedEvent();
		if (seWarning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
			return;
		}
		Event relaxed = selectedEntity.getRelaxed(); 
		selectedEntity.getValueOrTextValueEvent().unselect();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar();
        mToolBar.select(relaxed, selectedEntity);

		var currentTime = relaxed.getEndTimeInfo();
		SS3Singleton.getMediaPlayer().seek(currentTime);


		if(selectedEntity instanceof GestureEventsEntity) {
			GestureEventsEntity gestSelectedEntity = (GestureEventsEntity)selectedEntity;
			
			if(gestSelectedEntity.isLockedDomNdomAlignments()) {
				GestureEventsEntity ndGestEntity = gestSelectedEntity.getDependentGestureEntity();
				if(ndGestEntity != null && ndGestEntity.getRelaxed() == null) {
					String ndGestWarning = ndGestEntity.addRelaxedEvent();
					if(ndGestWarning != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(ndGestWarning);	
					}
				}
			}

			GestureLocationEntity depLocEntity = gestSelectedEntity.getDependentLocationEntity();
			if (depLocEntity != null) {
				depLocEntity.updateTimes();
			}
			
			GesturePropertyEntity depSignTypeEnt = gestSelectedEntity.getDependentGesturePropertyEntity();
			if (depSignTypeEnt != null) {
				depSignTypeEnt.updateTimes();
			}
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
   }
}
