package edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.handshapes.GestureHandShapeEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.orientationField.GestureOrientationEntity;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;

public class LockUnlockGesturePhonAlignmentsListener implements ActionListener {
	
	@Override
	public void actionPerformed(ActionEvent e) {
		GestureEventsEntity selectedEntity  = (GestureEventsEntity)SS3Singleton.getMediaToolBar(null).selectedEntity();
		
		boolean locked = !selectedEntity.isLockedGesturePhonAlignments();
		
		GestureChainedEventsEntity depHandEntity = selectedEntity.getDependentHandEntity();
		GestureHandShapeEntity depHandShapeEntity = selectedEntity.getDependentHandShapeEntity();
		GestureOrientationEntity depOrientationEntity = selectedEntity.getDependentFingerTipOrientationEntity();
		GestureOrientationEntity depPalmOrientationEntity = selectedEntity.getDependentPalmOrientationEntity();
		
		if(locked) {
			Time startTimeInfo = selectedEntity.getValueOrTextValueEvent().getStartTimeInfo();
			Time endTimeInfo = selectedEntity.getValueOrTextValueEvent().getEndTimeInfo();
			if (selectedEntity.getPrestrokeHold() != null) {
				startTimeInfo = selectedEntity.getPrestrokeHold().getStartTimeInfo();
			}
			if (selectedEntity.getPoststrokeHold() != null) {
				endTimeInfo = selectedEntity.getPoststrokeHold().getEndTimeInfo();
			}

			if(depHandEntity != null) {
				GestureChainedEventsEntity prevEntity = depHandEntity.getPreviousEntity();
				GestureChainedEventsEntity nextEntity = depHandEntity.getNextEntity();

				if( (prevEntity == null || prevEntity.getEndTimeInfo().lessThanOrEq(startTimeInfo) )
						&& (nextEntity == null || nextEntity.getStartTimeInfo().greaterThanOrEq(endTimeInfo) ) ) {
					
					depHandEntity.setStartTimeInfo(startTimeInfo);
					depHandEntity.setEndTimeInfo(endTimeInfo);
					
					if (depHandShapeEntity != null) {
						MediaToolbarCommons.setGestureHandshapeStartTime(depHandShapeEntity, startTimeInfo);
						MediaToolbarCommons.setGestureHandshapeEndTime(depHandShapeEntity, endTimeInfo);

						depHandShapeEntity.setLockedGesturePhonAlignments(locked);
					}

					if (depOrientationEntity != null) {
						MediaToolbarCommons.setGestureOrientationStartTime(depOrientationEntity, startTimeInfo);
						MediaToolbarCommons.setGestureOrientationEndTime(depOrientationEntity, endTimeInfo);

						depOrientationEntity.setLockedGesturePhonAlignments(locked);
					}

					if (depPalmOrientationEntity != null) {
						MediaToolbarCommons.setGestureOrientationStartTime(depPalmOrientationEntity, startTimeInfo);
						MediaToolbarCommons.setGestureOrientationEndTime(depPalmOrientationEntity, endTimeInfo);
						depPalmOrientationEntity.setLockedGesturePhonAlignments(locked);
					}
					
					depHandEntity.setLockedGesturePhonAlignments(locked);
					SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
				} else {
					SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CANT_LOCK_GESTURES);
					return;
				}
			}
			
			selectedEntity.setLockedGesturePhonAlignments(locked);
			
		} else {
			selectedEntity.setLockedGesturePhonAlignments(locked);
			if(depHandEntity != null) {
				depHandEntity.setLockedGesturePhonAlignments(locked);
			}
			if(depHandShapeEntity != null) {
				depHandShapeEntity.setLockedGesturePhonAlignments(locked);
			}
			if (depOrientationEntity != null) {
				depOrientationEntity.setLockedGesturePhonAlignments(locked);
			}

			if (depPalmOrientationEntity != null) {
				depPalmOrientationEntity.setLockedGesturePhonAlignments(locked);
			}

			SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().repaint();
		}
	}
}
