package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.locations;

import java.awt.*;
import java.util.Arrays;

public class PolygonHelper {
    public static Polygon scaleBy(double scale, Polygon polygon) {
        int[] xpoints = Arrays.copyOf(polygon.xpoints, polygon.npoints);
        int[] ypoints = Arrays.copyOf(polygon.ypoints, polygon.npoints);
        for (int i = 0; i < polygon.npoints; i++) {
            xpoints[i] *= scale;
            ypoints[i] *= scale;
        }
        return new Polygon(xpoints, ypoints, polygon.npoints);
    }

    public static Polygon translateBy(int x, int y, Polygon polygon) {
        int[] xpoints = Arrays.copyOf(polygon.xpoints, polygon.npoints);
        int[] ypoints = Arrays.copyOf(polygon.ypoints, polygon.npoints);
        for (int i = 0; i < polygon.npoints; i++) {
            xpoints[i] += x;
            ypoints[i] += y;
        }
        return new Polygon(xpoints, ypoints, polygon.npoints);
    }

    public static Polygon flipHorizontal(int width, Polygon polygon) {
        int[] xpoints = Arrays.copyOf(polygon.xpoints, polygon.npoints);
        for (int i = 0; i < polygon.npoints; i++) {
            xpoints[i] = width - xpoints[i];
        }
        return new Polygon(xpoints, polygon.ypoints, polygon.npoints);
    }

}
