package edu.bu.signstream.grepresentation.fields.glossField.dialog.handShapes;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.ScrollPaneConstants;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.HandShapePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.LettersHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.NumbersHandshapesPallete;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.PaletteUtil;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.SortedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.UnmarkedHandshapesPalette;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.SelectedHandshapesPanel;
import edu.bu.signstream.grepresentation.fields.palettes.LettersPalette;
import edu.bu.signstream.ui.ButtonPanel;

public class GeneralHandshapePalette extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private final SS3CodingScheme scheme;
	private final HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();
	private SelectedHandshapesPanel panel = null;
	private JPanel client = null;
	protected JScrollPane sp = null;

	private final JButton clean = new JButton("Clear");
	
	private JPanel iconPanel;
	
	private ArrayList<SS3FieldValue> values = new ArrayList<SS3FieldValue>();
	private final ArrayList<HandShapeImage> selectedHshImages = new ArrayList<HandShapeImage>();
	
	private PaletteUtil paletteUtil = null;

	public GeneralHandshapePalette(ArrayList<SS3FieldValue> values, ArrayList<HandShapeImage> selectedHshImages, SS3CodingScheme scheme, int selectedIndex, HandShapePanel hsPanel) {
		this.scheme = scheme;
		this.values = values;
		this.selectedHshImages.addAll(selectedHshImages);

		if (values == null) {
            this.panel = new SelectedHandshapesPanel(scheme);
		} else {
            this.panel = new SelectedHandshapesPanel(selectedHshImages, scheme, hsPanel);
		}
		
		this.paletteUtil = new PaletteUtil(scheme, this.panel);

        this.iconPanel = new JPanel();

        this.setPalette(selectedIndex);
        this.setMinimumSize(this.getPreferredSize());
	}

	// GD 2024-07-17 - as of now not seeing these used, so commenting it out to avoid confusion.
	// actual palette switching happens in GlossPaletteDialog itemStateChanged
	public void setPalette(int selectedIndex) {

//        this.paletteUtil.setLetter(false);
//		
//        if(selectedIndex == 0) {
//        	//all
//            this.iconPanel = new SortedHandshapesPalette(this.values, this.paletteUtil);
//        } else if(selectedIndex == 1) {
//        	//letters
////            this.iconPanel = new LettersHandshapesPalette(this.values, this.paletteUtil, this.getSelectedHandshapes());
////            this.panel.setLettersHandshapesPallet((LettersHandshapesPalette) this.iconPanel);
//            new LettersPalette<>(super.getFormBean(), super.getScheme(), super.getParentHandShapePanel(), super.getSelectionPanel(), super.getPaletteInformationHelper().getCurrentTemplateID(), super.getPaletteInformationHelper().getCurrentDomPaletteID());
//
//        	this.iconPanel = new LettersPalette(null, scheme, panel, panel, name, name);
//            this.panel.setLettersPalette((LettersPalette) this.iconPanel);
//            this.paletteUtil.setLetter(true);
//        } else if(selectedIndex == 2) {
//        	//numbers
//            this.iconPanel = new NumbersHandshapesPallete(this.values, this.panel, this.scheme);
//        } else {
//        	//unmarked
//            this.iconPanel = new UnmarkedHandshapesPalette(this.values, this.panel, this.scheme);
//        }
//
//        this.removeAll();
//
//        this.initUI();
//        this.invalidate();
//        this.revalidate();
	}
	
	private void initUI() {
		Dimension d = new Dimension(this.getPreferredSize().width+10, 50);
        this.panel.setPreferredSize(d);

        this.sp = new JScrollPane(this.panel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        this.sp.getViewport().setScrollMode(JViewport.SIMPLE_SCROLL_MODE);

		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());

		JScrollPane jsp = new JScrollPane(this.iconPanel, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		Dimension dim = new Dimension(450, 300);
		jsp.setMaximumSize(dim);
		jsp.setPreferredSize(dim);

//		Dimension spd = new Dimension(getPreferredSize().width - 50, 60);
//		//Dimension spd = new Dimension(getPreferredSize().width - 150, 60);
//
//		sp.setMaximumSize(spd);
//		sp.setPreferredSize(spd);
//		sp.setMinimumSize(spd);

        this.client = new JPanel();
        this.client.setLayout(new BorderLayout(10, 10));
        this.client.add(this.sp, BorderLayout.SOUTH);

//		p.add(iconPanel, BorderLayout.CENTER);   
		p.add(jsp, BorderLayout.NORTH);
		if (this.iconPanel instanceof LettersHandshapesPalette)
			p.add(this.paletteUtil.getLettersTxtfld(), BorderLayout.CENTER);
		else {
			JPanel padding = new JPanel();
			Dimension pref = new Dimension(padding.getPreferredSize().width, padding.getPreferredSize().height + 10);
			padding.setPreferredSize(pref);
			p.add(padding);
		}
		p.add(this.client, BorderLayout.SOUTH);
		p.setMinimumSize(p.getPreferredSize());

		ButtonPanel bp = new ButtonPanel();
		bp.add(this.clean);
        this.clean.addActionListener(this);

        this.setLayout(new BorderLayout());

        this.add(p, BorderLayout.CENTER);
        this.add(bp, BorderLayout.SOUTH);
	}

	public void setSelectedHshImages(ArrayList<HandShapeImage> selectedHshImages) {
        // panel = new SelectedHandshapesPanel(selectedHshImages);
		this.selectedHshImages.clear();
		this.selectedHshImages.addAll(selectedHshImages);
        this.panel.update(this.selectedHshImages);
    }

	@Override
	public void actionPerformed(ActionEvent ae) {
        this.panel.removeAll();
		
		if(this.iconPanel instanceof LettersHandshapesPalette) {
			LettersHandshapesPalette p = (LettersHandshapesPalette) this.iconPanel;
			p.clearEnteredIcons();
		}
	}

	public ArrayList<HandShapeImage> getSelectedHandshapes() {
        this.setSelectedHshImages(this.panel.getHandshapes());	// sets selectedHshImages
		return this.selectedHshImages;
	}

	public SelectedHandshapesPanel getSelectedHandshapesPanel() {
		return this.panel;
	}
	
}
