package edu.bu.signstream.grepresentation.fields.movementField;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEvent;
import edu.bu.signstream.ui.ButtonPanel;

public class NewMovementDialog extends JDialog implements ActionListener {
	private final int CANCEL = 4;
	private final int OK = 5;

	private NewMovementPanel sPanel;

	private ChainedEvent event = null;

	private JButton btnCancel = new JButton(" Cancel ");
	private JButton btnOk = new JButton(" OK ");

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();

	public NewMovementDialog(ChainedEvent event, SS3CodingScheme cs) {
		super(SS3Singleton.getSignStreamApplication(), "SignStream 3.0", true);
		this.event = event;

		sPanel = new NewMovementPanel(cs);

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				dispose();
			}
		});

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(50, 50));
		contentPane.add(createPanel(), BorderLayout.CENTER);
		this.pack();
	}

	public JPanel createPanel() {
		//btnSelect.setIcon(new ImageIcon(ImageMaker.EXECUTE_ICON));
		btnCancel.setToolTipText("Check this to cancel.");
		//btnSelect.setMnemonic(KeyEvent.VK_S);
		btnCancel.setActionCommand("" + CANCEL);

		//btnCancel.setIcon(new ImageIcon(ImageMaker.CLOSE_ICON));
		btnOk.setToolTipText("Check this to select checked fields.");
		//btnCancel.setMnemonic(KeyEvent.VK_S);
		btnOk.setActionCommand("" + OK);

		btnCancel.addActionListener(this);
		btnOk.addActionListener(this);

		Dimension dim = new Dimension(80, 21);
		btnCancel.setPreferredSize(dim);
		btnOk.setPreferredSize(dim);

		ButtonPanel btnPanel = new ButtonPanel();
		btnPanel.add(btnOk);
		btnPanel.add(btnCancel);

		int width = (int) (sPanel.getPreferredSize().getWidth() + 30);
		int height = (int) sPanel.getPreferredSize().getHeight() + 20;

		sPanel.setPreferredSize(new Dimension(width, height));

		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(sPanel, BorderLayout.CENTER);
		panel.add(btnPanel, BorderLayout.SOUTH);
		panel.setBorder(BorderFactory.createEmptyBorder(0, 10, 0, 10));
		return panel;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String str = ae.getActionCommand();

		switch (Integer.parseInt(str)) {
			case CANCEL :
				this.dispose();
				break;
			case OK :
				event.setID(sPanel.getSelecteedIDs());
				this.dispose();
				break;
		}
	}

}
