package edu.bu.signstream.grepresentation.fields.movementField;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SpringLayout;

import edu.bu.signstream.common.util.vo.Constants;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.ValueCollection;

public class NewMovementPanel extends JPanel {
	private ArrayList dirMovValues = new ArrayList();
	private ArrayList movContValues = new ArrayList();
	private ArrayList repetValues = new ArrayList();
	private ArrayList coordValues = new ArrayList();
	private ArrayList mTouchValues = new ArrayList();

	private JList directMovList = null;
	private JList movContourList = null;
	private JList repetitionList = null;
	private JList coordinationList = null;
	private JList mannerOfTouchList = null;

	public NewMovementPanel(SS3CodingScheme cs) {
		createUI(cs);
	}

	private void createUI(SS3CodingScheme cs) {
		JPanel lPanel = new JPanel();
		JPanel cPanel = new JPanel();
		JPanel rPanel = new JPanel();

		// directional movement
		ValueCollection dirMovCol =
			cs.getValueCollection(Constants.VC_DIRECTIONAL_MOVEMENT);
		dirMovValues = dirMovCol.getFieldValues();
		DefaultListModel dirMovModel = new DefaultListModel();
		for (int i = 0; i < dirMovValues.size(); i++) {
			SS3FieldValue value = (SS3FieldValue) dirMovValues.get(i);
			dirMovModel.addElement(value.getName());
		}

		directMovList = new JList(dirMovModel);
		directMovList.setSelectionMode(
			ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		directMovList.setLayoutOrientation(JList.VERTICAL);
		directMovList.setVisibleRowCount(-1);

		JScrollPane directMovScroller = new JScrollPane(directMovList);
		directMovScroller.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		directMovScroller.setPreferredSize(new Dimension(150, 80));

		// movement contour
		ValueCollection movContCol =
			cs.getValueCollection(Constants.VC_MOVEMENT_CONTOUR);
		movContValues = movContCol.getFieldValues();
		DefaultListModel movContModel = new DefaultListModel();
		for (int i = 0; i < movContValues.size(); i++) {
			SS3FieldValue value = (SS3FieldValue) movContValues.get(i);
			movContModel.addElement(value.getName());
		}

		movContourList = new JList(movContModel);
		movContourList.setSelectionMode(
			ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		movContourList.setLayoutOrientation(JList.VERTICAL);
		movContourList.setVisibleRowCount(-1);

		JScrollPane movContourScroller = new JScrollPane(movContourList);
		movContourScroller.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		movContourScroller.setPreferredSize(new Dimension(150, 80));

		// repetition
		ValueCollection repetCol =
			cs.getValueCollection(Constants.VC_REPETITION);
		repetValues = repetCol.getFieldValues();
		DefaultListModel repetModel = new DefaultListModel();
		for (int i = 0; i < repetValues.size(); i++) {
			SS3FieldValue value = (SS3FieldValue) repetValues.get(i);
			repetModel.addElement(value.getName());
		}

		repetitionList = new JList(repetModel);
		repetitionList.setSelectionMode(
			ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		repetitionList.setLayoutOrientation(JList.VERTICAL);
		repetitionList.setVisibleRowCount(-1);

		JScrollPane repetitionScroller = new JScrollPane(repetitionList);
		repetitionScroller.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		repetitionScroller.setPreferredSize(new Dimension(150, 80));

		// coordination
		ValueCollection coordCol =
			cs.getValueCollection(Constants.VC_COORDINATION);
		coordValues = coordCol.getFieldValues();
		DefaultListModel coordModel = new DefaultListModel();
		for (int i = 0; i < coordValues.size(); i++) {
			SS3FieldValue value = (SS3FieldValue) coordValues.get(i);
			coordModel.addElement(value.getName());
		}

		coordinationList = new JList(coordModel);
		coordinationList.setSelectionMode(
			ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		coordinationList.setLayoutOrientation(JList.VERTICAL);
		coordinationList.setVisibleRowCount(-1);

		JScrollPane coordinationScroller = new JScrollPane(coordinationList);
		coordinationScroller.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		coordinationScroller.setPreferredSize(new Dimension(150, 80));

		// manner of touch
		ValueCollection mOfTouchCol =
			cs.getValueCollection(Constants.VC_MANER_OF_TOUCH);
		mTouchValues = mOfTouchCol.getFieldValues();
		DefaultListModel mOfTouchModel = new DefaultListModel();
		for (int i = 0; i < mTouchValues.size(); i++) {
			SS3FieldValue value = (SS3FieldValue) mTouchValues.get(i);
			mOfTouchModel.addElement(value.getName());
		}

		mannerOfTouchList = new JList(mOfTouchModel);
		mannerOfTouchList.setSelectionMode(
			ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		mannerOfTouchList.setLayoutOrientation(JList.VERTICAL);
		mannerOfTouchList.setVisibleRowCount(-1);

		JScrollPane mannerOfTouchScroller = new JScrollPane(mannerOfTouchList);
		mannerOfTouchScroller.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		mannerOfTouchScroller.setPreferredSize(new Dimension(150, 80));

		lPanel.setLayout(new GridLayout(0, 1, 5, 5));
		JPanel dmPanel = new JPanel();
		dmPanel.setLayout(new BorderLayout());
		dmPanel.add(new JLabel("Directional Movement"), BorderLayout.NORTH);
		dmPanel.add(directMovScroller, BorderLayout.CENTER);
		lPanel.add(dmPanel);

		JPanel mcPanel = new JPanel();
		mcPanel.setLayout(new BorderLayout());
		mcPanel.add(new JLabel("Movement Contour"), BorderLayout.NORTH);
		mcPanel.add(movContourScroller, BorderLayout.CENTER);
		lPanel.add(mcPanel);

		rPanel.setLayout(new GridLayout(0, 1, 5, 5));
		JPanel rptPanel = new JPanel();
		rptPanel.setLayout(new BorderLayout());
		rptPanel.add(new JLabel("Repetition"), BorderLayout.NORTH);
		rptPanel.add(repetitionScroller, BorderLayout.CENTER);
		rPanel.add(rptPanel);

		JPanel crdPanel = new JPanel();
		crdPanel.setLayout(new BorderLayout());
		crdPanel.add(new JLabel("Coordination"), BorderLayout.NORTH);
		crdPanel.add(coordinationScroller, BorderLayout.CENTER);
		rPanel.add(crdPanel);

		JPanel motPanel = new JPanel();
		motPanel.setLayout(new BorderLayout());
		motPanel.add(new JLabel("Manner of Touch"), BorderLayout.NORTH);
		motPanel.add(mannerOfTouchScroller, BorderLayout.CENTER);
		rPanel.add(motPanel);

		JPanel sPanel = new JPanel();
		sPanel.setLayout(new SpringLayout());
		sPanel.add(new JLabel("Selection: "));
		JTextField selTxt = new JTextField(26);
		sPanel.add(selTxt);
		sPanel.add(new JButton("Info"));

		cPanel.setLayout(new BorderLayout());
		cPanel.add(sPanel, BorderLayout.NORTH);
		cPanel.add(
			new JLabel("direction, contour, repetition, coordination, touch images will be here"),
			BorderLayout.CENTER);

		setLayout(new BorderLayout(10, 10));
		add(sPanel, BorderLayout.NORTH);
		add(lPanel, BorderLayout.WEST);
		add(cPanel, BorderLayout.CENTER);
		add(rPanel, BorderLayout.EAST);
	}

	public String getSelecteedIDs() {
		StringBuffer bf = new StringBuffer();

		int dmvIndex = directMovList.getSelectedIndex();
		int ctrIndex = movContourList.getSelectedIndex();
		int rptIndex = repetitionList.getSelectedIndex();
		int crdIndex = coordinationList.getSelectedIndex();
		int motIndex = mannerOfTouchList.getSelectedIndex();

		if (dmvIndex > -1) {
			SS3FieldValue dmValue = (SS3FieldValue) dirMovValues.get(dmvIndex);
			bf.append(Constants.VC_DIRECTIONAL_MOVEMENT);
			bf.append(".");
			bf.append(dmValue.getId());
		}

		if (ctrIndex > -1) {
			SS3FieldValue ctrValue = (SS3FieldValue) movContValues.get(ctrIndex);

			if (bf.length() > 0)
				bf.append("#");

			bf.append(Constants.VC_MOVEMENT_CONTOUR);
			bf.append(".");
			bf.append(ctrValue.getId());
		}

		if (rptIndex > -1) {
			SS3FieldValue rptValue = (SS3FieldValue) repetValues.get(rptIndex);

			if (bf.length() > 0)
				bf.append("#");

			bf.append(Constants.VC_REPETITION);
			bf.append(".");
			bf.append(rptValue.getId());
		}

		if (crdIndex > -1) {
			SS3FieldValue crdValue = (SS3FieldValue) coordValues.get(crdIndex);

			if (bf.length() > 0)
				bf.append("#");

			bf.append(Constants.VC_COORDINATION);
			bf.append(".");
			bf.append(crdValue.getId());
		}

		if (motIndex > -1) {
			SS3FieldValue motValue = (SS3FieldValue) mTouchValues.get(motIndex);

			if (bf.length() > 0)
				bf.append("#");

			bf.append(Constants.VC_MANER_OF_TOUCH);
			bf.append(".");
			bf.append(motValue.getId());
		}

		return bf.toString();
	}
}
