package edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.handShapeField.HandShapeEntity;
import edu.bu.signstream.grepresentation.fields.locationField.LocationEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.signTypeField.SignTypeEntity;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolbarCommons;

public class AddInitialHoldActionListener implements ActionListener {
	private ChainedEventsEntity selectedEntity = null;

	public AddInitialHoldActionListener() {
	}

	public void setSelectedEntity(ChainedEventsEntity entity) {
		this.selectedEntity = entity;
	}

	@Override
	public void actionPerformed(ActionEvent e) {

//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton
				.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time minEntityStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getPrecedingFrameTimeInfo(
//						selectedEntity.getStartTimeInfo());

//		if (selectedEntity.getOnset() == null
//				&& minEntityStartTimeInfo.lessThan(utterance.getStartTimeInfo())) {
//			SS3Singleton.getErrorMessages().showErrorMessage(
//					ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//		}

		ChainedEventsEntity prevEntity = selectedEntity.getPreviousEntity();
		
		if (selectedEntity.getOnset() == null && prevEntity != null) {
			Time minHoldMovieTimeInfo = segmentPanel.getMultipleMovieController().getFollowingFrameTimeInfo(
					prevEntity.getEndTimeInfo());
			Time selectedEntityStartMovieTimeInfo = selectedEntity
					.getStartTimeInfo();

			if (selectedEntityStartMovieTimeInfo.lessThan(minHoldMovieTimeInfo)) {
				SS3Singleton.getErrorMessages().showErrorMessage(
						ErrorMessages.CHAINS_CANNOT_OVERLAP);
				return;
			}
		}

		String warning = selectedEntity.addInitialHoldEvent();
		if (warning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(warning);
			return;
		} 
		Event selectedEvent = selectedEntity.getInitialHold();

		selectedEntity.getValueOrTextValueEvent().unselect();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar();
        mToolBar.select(selectedEvent, selectedEntity);

        var currentTime = selectedEvent.getStartTimeInfo();
        SS3Singleton.getMediaPlayer().seek(currentTime);

		if (selectedEntity instanceof GlossChainedEventsEntity) {
			GlossChainedEventsEntity glsSelectedEntity = (GlossChainedEventsEntity) selectedEntity;
			boolean isLockedGlossAlignments = glsSelectedEntity.isLockedGlossPhonAlignments();
			boolean isLockedDomNdomAlignments = glsSelectedEntity.isLockedDomNdomAlignments();
			
			Time timeInfo = selectedEvent.getStartTimeInfo();
			
			if(isLockedGlossAlignments) {
				ChainedEventsEntity handEntity  = glsSelectedEntity.getDependentHandEntity();
				HandShapeEntity handShapeEntity = glsSelectedEntity.getDependentHandShapeEntity();
				
				if(handEntity != null) {
					ChainedEventsEntity prvHndEntity = handEntity.getPreviousEntity();

					if (prvHndEntity == null) {
						Event txt = handEntity.getTextValue();
						Event value = handEntity.getValue();
						Event txtOrValue = handEntity.getValueOrTextValueEvent();
						
						handEntity.getValueOrTextValueEvent().setStartTimeInfo(timeInfo);
					} else if (prvHndEntity.getEndTimeInfo().greaterThan(timeInfo)) {
						SS3Singleton.getErrorMessages().showErrorMessage(
								ErrorMessages.CHAINS_CANNOT_OVERLAP);
						return;
					} else {
						handEntity.getTextValue().setStartTimeInfo(timeInfo);
					}
					
					if(handShapeEntity != null) {
						Event valueOrTextEvent = selectedEntity.getValueOrTextValueEvent();
						Event initialHoldEvent = selectedEntity.getInitialHold();
						initialHoldEvent = initialHoldEvent != null ? initialHoldEvent : valueOrTextEvent;
						Event finalHoldEvent = selectedEntity.getFinalHold();
						finalHoldEvent = finalHoldEvent != null ? finalHoldEvent : valueOrTextEvent;
						
						if (handShapeEntity.getEvents().size() != 1) {
							handShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(initialHoldEvent.getStartTimeInfo());
							handShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(initialHoldEvent.getStartTimeInfo());

							handShapeEntity.getLastHandShapeEvent().setStartTimeInfo(finalHoldEvent.getEndTimeInfo());
							handShapeEntity.getLastHandShapeEvent().setEndTimeInfo(finalHoldEvent.getEndTimeInfo());
						} else {
							handShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(initialHoldEvent.getStartTimeInfo());
							handShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(finalHoldEvent.getEndTimeInfo());
						}

						MediaToolbarCommons.setHandshapeStartTime(
								handShapeEntity, initialHoldEvent.getStartTimeInfo());
					}
				}
			}
			
			if(isLockedDomNdomAlignments) {
				GlossChainedEventsEntity depGlsEntity = glsSelectedEntity.getDependentGlossEntity();
				if(depGlsEntity != null && depGlsEntity.getInitialHold() == null) {
					ChainedEventsEntity prevDepGlsEntity = depGlsEntity.getPreviousEntity();

					if (depGlsEntity.getOnset() == null && prevDepGlsEntity != null) {
						Time minHoldMovieTimeInfo = segmentPanel.getMultipleMovieController().getFollowingFrameTimeInfo(
								prevDepGlsEntity.getEndTimeInfo());
						Time selectedEntityStartMovieTimeInfo = depGlsEntity.getStartTimeInfo();

						if (selectedEntityStartMovieTimeInfo.lessThan(minHoldMovieTimeInfo)) {
							SS3Singleton.getErrorMessages().showErrorMessage(
									ErrorMessages.CHAINS_CANNOT_OVERLAP);
							return;
						}
					}
					
					String depWarning = depGlsEntity.addInitialHoldEvent();
					if (depWarning != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(depWarning);
						return;
					}
					if(depGlsEntity.isLockedGlossPhonAlignments()) {
						ChainedEventsEntity depHandEntity = depGlsEntity.getDependentHandEntity();
						HandShapeEntity depHandShapeEntity = depGlsEntity.getDependentHandShapeEntity();
						
						if(depHandEntity != null) {
							ChainedEventsEntity prvHndEntity = depHandEntity.getPreviousEntity();

							if (prvHndEntity == null) {
								depHandEntity.getTextValue().setStartTimeInfo(timeInfo);
							} else if (prvHndEntity.getEndTimeInfo().greaterThan(timeInfo)) {
								SS3Singleton.getErrorMessages().showErrorMessage(
										ErrorMessages.CHAINS_CANNOT_OVERLAP);
								return;
							} else {
								depHandEntity.getTextValue().setStartTimeInfo(timeInfo);
							}
						
							if(depHandShapeEntity != null) {
								Event valueOrTextEvent = depGlsEntity.getValueOrTextValueEvent();
								Event initialHoldEvent = depGlsEntity.getInitialHold();
								initialHoldEvent = initialHoldEvent != null ? initialHoldEvent : valueOrTextEvent;
								Event finalHoldEvent = depGlsEntity.getFinalHold();
								finalHoldEvent = finalHoldEvent != null ? finalHoldEvent : valueOrTextEvent;
								
								if (depHandShapeEntity.getEvents().size() != 1) {
									depHandShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(initialHoldEvent.getStartTimeInfo());
									depHandShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(initialHoldEvent.getStartTimeInfo());

									depHandShapeEntity.getLastHandShapeEvent().setStartTimeInfo(finalHoldEvent.getEndTimeInfo());
									depHandShapeEntity.getLastHandShapeEvent().setEndTimeInfo(finalHoldEvent.getEndTimeInfo());
								} else {
									depHandShapeEntity.getFirstHandShapeEvent().setStartTimeInfo(initialHoldEvent.getStartTimeInfo());
									depHandShapeEntity.getFirstHandShapeEvent().setEndTimeInfo(finalHoldEvent.getEndTimeInfo());
								}

								MediaToolbarCommons.setHandshapeStartTime(
										depHandShapeEntity, initialHoldEvent.getStartTimeInfo());
							}
						}
					}
				}
			}

			LocationEntity depLocEntity = glsSelectedEntity.getDependentLocationEntity();
			if (depLocEntity != null) {
				depLocEntity.updateTimes();
			}
			
			SignTypeEntity depSignTypeEnt = glsSelectedEntity.getDependentSignTypeEntity();
			if (depSignTypeEnt != null) {
				depSignTypeEnt.updateTimes();
			}
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
	}
}
