package edu.bu.signstream.grepresentation.listener;

import java.awt.event.*;
import java.util.ArrayList;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.ui.video.MultipleMovieController;
import edu.bu.signstream.ui.video.VideoControlPanel;

public class SSKeyListener implements KeyListener {

	public SSKeyListener() {
	}

	@Override
	public void keyPressed(KeyEvent e) {		
		
		int keyCode = e.getKeyCode();		
  		MultipleMovieController controller = SS3Singleton.getVideoControlManager().getMultipleMovieController();

  		var bar = SS3Singleton.getMediaToolBar(SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel());

        var player = SS3Singleton.getMediaPlayer();
        var step = Util.getStep();
        var range = Util.getStepRange();

        if (keyCode == KeyEvent.VK_RIGHT) {
            player.seek(player.time().add(step).in(range));
        } else if (keyCode == KeyEvent.VK_LEFT) {
            player.seek(player.time().subtract(step).in(range));
		} else if(keyCode == KeyEvent.VK_SPACE) {
						
			if(controller.isPlaying()) {
				controller.pause();
			} else {
				ArrayList<VideoControlPanel> videoPanels = SS3Singleton.getVideoControlManager().getVideoControlPanels();
				if(!videoPanels.isEmpty()) {
					VideoControlPanel videoControlPanel = videoPanels.get(0);
					videoControlPanel.playPause();
				}
			}
		}		
		
	}

	@Override
	public void keyReleased(KeyEvent e) {
	}

	@Override
	public void keyTyped(KeyEvent e) {
	}
}
