package edu.bu.signstream.grepresentation.requestsHandler;

import java.awt.Point;


import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import edu.bu.signstream.common.util.UserInterfaceUtil;
import edu.bu.signstream.common.util.Util;

import edu.bu.signstream.grepresentation.fields.apexField.ApexChainedApexEventsEntity;

import edu.bu.signstream.grepresentation.fields.apexField.mouseDelegateListeners.AddApexActionListener;
import edu.bu.signstream.grepresentation.fields.apexField.mouseDelegateListeners.AddApexOffsetActionListener;
import edu.bu.signstream.grepresentation.fields.apexField.mouseDelegateListeners.AddApexOnsetActionListener;

import edu.bu.signstream.grepresentation.fields.apexField.mouseDelegateListeners.DeleteApexActionListener;

import edu.bu.signstream.grepresentation.fields.gestureField.GestureCompoundable;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEventsEntity;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.GestureInfoDialog;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.AddGesturePoststrokeHoldActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.AddGesturePrestrokeHoldActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.AddGestureRetractionActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.AddGestureRelaxedActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.AddGesturePreparationActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.DefineGestureAssociatedFieldsActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.DeleteGestureActionListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.LinkUnlinkGestureCompound;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.LinkUnlinkGestureMenuItem;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.LockUnlockGesturePhonAlignmentsListener;
import edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners.LockUnlockGestureDomNdomHandAlignmentsListener;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.IPAKeyboard;
import edu.bu.signstream.grepresentation.view.GestureNRelatedView;
import edu.bu.signstream.grepresentation.view.SegmentTemplate;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class GestureFieldDialogs {

	final JPopupMenu popup = new JPopupMenu();

	private JMenu assocEventsMenu = null;
	private JMenuItem addOnset = null;
	private JMenuItem addInitialHold = null;
	private JMenuItem addFinalHold = null;
	private JMenuItem addOffset = null;
	private JMenuItem addRelaxed = null;
	private JMenuItem delete = null;
	private JMenuItem cancel = null;
	private JMenuItem defAsFlds = null;
	private JMenu apexMenu = null;
	private JMenuItem addApexItem = null;
	private JMenuItem deleteApexItem = null;
	private JMenuItem addApexOnsetItem = null;
	private JMenuItem deleteApexOnsetItem = null;
	private JMenuItem addApexOffsetItem = null;
	private JMenuItem deleteApexOffsetItem = null;
	private JMenu compoundsMenu = null;

	private JMenuItem lockHandAlignments = null;
	private JMenuItem lockGesturePhonAlignments = null; 

	private AddGesturePreparationActionListener addGesturePreparationListener = null;
	private AddGesturePrestrokeHoldActionListener addGesturePrestrokeHoldListener = null;
	private AddGesturePoststrokeHoldActionListener addGesturePoststrokeHoldListener = null;
	private AddGestureRetractionActionListener addGestureRetractionListener = null;
	private AddGestureRelaxedActionListener addGestureRelaxedListener = null;
	private DeleteGestureActionListener deleteGestureActionListener = null;
	private DefineGestureAssociatedFieldsActionListener defGestureAssocFldsListener = null;

	private LinkUnlinkGestureMenuItem linkGestureStartCmp = new LinkUnlinkGestureMenuItem();
	private LinkUnlinkGestureMenuItem unlinkGestureStartCmp = new LinkUnlinkGestureMenuItem();
	private LinkUnlinkGestureMenuItem linkGestureEndCmp = new LinkUnlinkGestureMenuItem();
	private LinkUnlinkGestureMenuItem unlinkGestureEndCmp = new LinkUnlinkGestureMenuItem();

	private LinkUnlinkGestureCompound linkUnlinkGestureCmpListener = new LinkUnlinkGestureCompound();

    private IPAKeyboard ipaKeyboard;
    private GestureInfoDialog gestureInfoDialog = null;    

    public IPAKeyboard getIPAKeyboard() {
    	if (ipaKeyboard == null) {
    		ipaKeyboard = new IPAKeyboard();
    	}
		return ipaKeyboard;
	}

    public GestureInfoDialog getGestureInfoDialog() {
		return gestureInfoDialog;
	}

	public void setGestureInfoDialog(GestureInfoDialog gestureInfoDialog) {
		this.gestureInfoDialog = gestureInfoDialog;
	}

	
	public void getAssociatedElelmentsMenu(GestureChainedEventsEntity entity,
			Point point, JPanel panel) {
		
		SignStreamSegmentPanel segmentPanel = SS3Singleton
				.getSignStreamApplication().getSignStreamSegmentPanel();
		SegmentTemplate template = segmentPanel.getUtteranceView()
				.getSegmentTemplate(entity.getField().getSegmentID());
		GestureNRelatedView view = template.getSpeechView();
		GestureFieldWrapper wrapper = (GestureFieldWrapper) view
				.getFieldWrappersCollection().getFieldWrapperWithFieldID(
						entity.getField().getFieldID());

		if (assocEventsMenu == null) {
			assocEventsMenu = new JMenu("Associated Elements");

			UserInterfaceUtil.setMenuItemLNF(assocEventsMenu);
			popup.add(assocEventsMenu);

			addOnset = new JMenuItem("Preparation");
			addInitialHold = new JMenuItem("Pre-stroke Hold");
			addFinalHold = new JMenuItem("Post-stroke Hold");
			addOffset = new JMenuItem("Retraction");
			addRelaxed = new JMenuItem("Relaxed");
			delete = new JMenuItem("Delete");
			cancel = new JMenuItem("Cancel");
			apexMenu = new JMenu("Apex");

			defAsFlds = new JMenuItem("Gesture Info");
			
			lockHandAlignments = new JMenuItem("Lock/Unlock Dom-Ndom Gesture Alignments");
			lockGesturePhonAlignments = new JMenuItem("Lock/Unlock Dom Hand Alignments"); 
			
			compoundsMenu = new JMenu("Compounds");

			UserInterfaceUtil.setMenuItemLNF(addOnset);
			UserInterfaceUtil.setMenuItemLNF(addInitialHold);
			UserInterfaceUtil.setMenuItemLNF(addFinalHold);
			UserInterfaceUtil.setMenuItemLNF(addOffset);
			UserInterfaceUtil.setMenuItemLNF(addRelaxed);
			UserInterfaceUtil.setMenuItemLNF(defAsFlds);
			UserInterfaceUtil.setMenuItemLNF(lockHandAlignments);
			UserInterfaceUtil.setMenuItemLNF(lockGesturePhonAlignments);
			UserInterfaceUtil.setMenuItemLNF(compoundsMenu);
			UserInterfaceUtil.setMenuItemLNF(delete);
			UserInterfaceUtil.setMenuItemLNF(delete);
			UserInterfaceUtil.setMenuItemLNF(cancel);

			addGesturePreparationListener = new AddGesturePreparationActionListener();
			addGesturePrestrokeHoldListener = new AddGesturePrestrokeHoldActionListener();
			addGesturePoststrokeHoldListener = new AddGesturePoststrokeHoldActionListener();
			addGestureRetractionListener = new AddGestureRetractionActionListener();
			addGestureRelaxedListener = new AddGestureRelaxedActionListener();
			deleteGestureActionListener = new DeleteGestureActionListener();

			lockHandAlignments.addActionListener(new LockUnlockGestureDomNdomHandAlignmentsListener());
			lockGesturePhonAlignments.addActionListener(new LockUnlockGesturePhonAlignmentsListener());

			addOnset.addActionListener(addGesturePreparationListener);
			addInitialHold.addActionListener(addGesturePrestrokeHoldListener);
			addFinalHold.addActionListener(addGesturePoststrokeHoldListener);
			addOffset.addActionListener(addGestureRetractionListener);
			addRelaxed.addActionListener(addGestureRelaxedListener);
			delete.addActionListener(deleteGestureActionListener);

            if(entity instanceof GestureEventsEntity) {
                defGestureAssocFldsListener = new DefineGestureAssociatedFieldsActionListener(wrapper, view);
			    defAsFlds.addActionListener(defGestureAssocFldsListener);
            }

			linkGestureStartCmp.addActionListener(linkUnlinkGestureCmpListener);
			unlinkGestureStartCmp.addActionListener(linkUnlinkGestureCmpListener);
			linkGestureEndCmp.addActionListener(linkUnlinkGestureCmpListener);
			unlinkGestureEndCmp.addActionListener(linkUnlinkGestureCmpListener);

			popup.add(delete);
			popup.add(cancel);
		} else {
            if(entity instanceof GestureEventsEntity) {
                if(defGestureAssocFldsListener == null) {
                    defGestureAssocFldsListener = new DefineGestureAssociatedFieldsActionListener(wrapper, view);
                    defAsFlds.addActionListener(defGestureAssocFldsListener);
                } else {
			        defGestureAssocFldsListener.setUpdatedValues(wrapper, view);
                }
            }
		}

		assocEventsMenu.remove(addOnset);
		assocEventsMenu.remove(addInitialHold);
		assocEventsMenu.remove(addFinalHold);
		assocEventsMenu.remove(addOffset);
		assocEventsMenu.remove(addRelaxed);

		popup.remove(defAsFlds);
		popup.remove(apexMenu);
		popup.remove(lockHandAlignments);
		popup.remove(lockGesturePhonAlignments);
		popup.remove(compoundsMenu);

		if (entity.getPreparation() == null) {
			addGesturePreparationListener.setSelectedEntity(entity);
			assocEventsMenu.add(addOnset);
		}

		if (entity.getPrestrokeHold() == null) {
			addGesturePrestrokeHoldListener.setSelectedEntity(entity);
			assocEventsMenu.add(addInitialHold);
		}

		if (entity.getPoststrokeHold() == null) {
			addGesturePoststrokeHoldListener.setSelectedEntity(entity);
			assocEventsMenu.add(addFinalHold);
		}

		if (entity.getRetraction() == null) {
			addGestureRetractionListener.setSelectedEntity(entity);
			assocEventsMenu.add(addOffset);
		}
		
		if (entity.getRelaxed() == null) {
			addGestureRelaxedListener.setSelectedEntity(entity);
			assocEventsMenu.add(addRelaxed);
		}

		deleteGestureActionListener.setChainedEventsEntity(entity);

		if (entity instanceof GestureEventsEntity) {

			GestureEventsEntity gestEntity = (GestureEventsEntity) entity;

			int popupCounter = 0;
			
			popup.add(defAsFlds, popupCounter);
			popupCounter ++;
			
			popupCounter ++;
			
			// Apex Menu
			apexMenu = new JMenu("Apex");
			addApexItem = new JMenuItem("Add Apex");
			deleteApexItem = new JMenuItem("Delete Apex");
			addApexOnsetItem = new JMenuItem("Add Apex Onset");
			addApexOffsetItem = new JMenuItem("Add Apex Offset");
			deleteApexOnsetItem = new JMenuItem("Delete Apex Onset");
			deleteApexOffsetItem = new JMenuItem("Delete Apex Offset");
			
			UserInterfaceUtil.setMenuItemLNF(apexMenu);
			UserInterfaceUtil.setMenuItemLNF(addApexItem);
			UserInterfaceUtil.setMenuItemLNF(deleteApexItem);
			UserInterfaceUtil.setMenuItemLNF(addApexOnsetItem);
			UserInterfaceUtil.setMenuItemLNF(addApexOffsetItem);
			UserInterfaceUtil.setMenuItemLNF(deleteApexOnsetItem);
			UserInterfaceUtil.setMenuItemLNF(deleteApexOffsetItem);
			
			popup.add(apexMenu, popupCounter);
			popupCounter++;
			
			apexMenu.remove(addApexItem);
			apexMenu.remove(deleteApexItem);
			apexMenu.remove(addApexOnsetItem);
			apexMenu.remove(deleteApexOnsetItem);
			apexMenu.remove(addApexOffsetItem);
			apexMenu.remove(deleteApexOffsetItem);
			
			if (gestEntity.getDependentApexEntity() == null) {
				apexMenu.add(addApexItem);
			} else {
				ApexChainedApexEventsEntity apexEntity = gestEntity.getDependentApexEntity();
				if (apexEntity.getOnset() == null) {
					apexMenu.add(addApexOnsetItem);
				} else {
					apexMenu.add(deleteApexOnsetItem);
				}
				if (apexEntity.getOffset() == null) {
					apexMenu.add(addApexOffsetItem);
				} else {
					apexMenu.add(deleteApexOffsetItem);
				}
				apexMenu.add(deleteApexItem);
			}
			
			addApexItem.addActionListener(new AddApexActionListener(view, gestEntity));
			deleteApexItem.addActionListener(new DeleteApexActionListener(gestEntity, gestEntity.getDependentApexEntity()));
			addApexOnsetItem.addActionListener(new AddApexOnsetActionListener(gestEntity.getDependentApexEntity()));
			deleteApexOnsetItem.addActionListener((e) -> {
				gestEntity.getDependentApexEntity().deleteOnset();
				SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
				panel.repaint();
			});
			addApexOffsetItem.addActionListener(new AddApexOffsetActionListener(gestEntity.getDependentApexEntity()));
			deleteApexOffsetItem.addActionListener((e) -> {
				gestEntity.getDependentApexEntity().deleteOffset();
				SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
				panel.repaint();
			});
			// End Apex Menu
			
			popupCounter ++;
			
			GestureEventsEntity dGestEntity =  gestEntity.getDependentGestureEntity();
			GestureChainedEventsEntity dHandEntity = gestEntity.getDependentHandEntity();
			
			if(dGestEntity != null) {
				boolean lockedDomNdomAlignment = gestEntity.isLockedDomNdomAlignments();
				
				if(lockedDomNdomAlignment) {
					lockHandAlignments.setText("Unlock Dom-Ndom Gesture Alignments");
				} else {
					lockHandAlignments.setText("Lock Dom-Ndom Gesture Alignments");
				}
				popup.add(lockHandAlignments, popupCounter);
				popupCounter ++;
			}
			
			if(dHandEntity != null) {
				boolean lockedGestPhonAlignment = gestEntity.isLockedGesturePhonAlignments();
				String fieldID = dHandEntity.getField().getFieldID();
				
				boolean isDomHand =fieldID.equals(Util.DOM_GESTURE_HAND_FIELD_ID);
				
				if(lockedGestPhonAlignment) {
					if(isDomHand) {
						lockGesturePhonAlignments.setText("Unlock Dom Hand Alignments");
					} else {
						lockGesturePhonAlignments.setText("Unlock Ndom Hand Alignments");
					}
				} else {
					if(isDomHand) {
						lockGesturePhonAlignments.setText("Lock Dom Hand Alignments");
					} else {
						lockGesturePhonAlignments.setText("Lock Ndom Hand Alignments");
					}
				}
				popup.add(lockGesturePhonAlignments, popupCounter);
				popupCounter ++;
			}

			GestureEventsEntity prevEntity = gestEntity.getPreviousEntity();
			GestureEventsEntity nextEntity = gestEntity.getNextEntity();
			
//			Event utterance = entity.getParentEntity().getEvent();
//			Event prevEntityUtterance = null; 
//			Event nextEntityUtterance = null; 
//			if (prevEntity != null) {
//				prevEntityUtterance = prevEntity.getParentEntity().getEvent();
//			}
//			if (nextEntity != null) {
//				nextEntityUtterance = nextEntity.getParentEntity().getEvent();
//			}
			
			GestureCompoundable startCompound = gestEntity.getStartCompound();
			GestureCompoundable endCompound = gestEntity.getEndCompound();
			
//			//add compounds to the menu, only if there are other entities in the same utterance
//			//or if there are existing compounds to remove
//			if (utterance.equals(prevEntityUtterance) || utterance.equals(nextEntityUtterance) ||
//					startCompound != null || endCompound != null) {
			if (startCompound != null || endCompound != null) {
				
				compoundsMenu.remove(linkGestureStartCmp);
				compoundsMenu.remove(unlinkGestureStartCmp);
				compoundsMenu.remove(linkGestureEndCmp);
				compoundsMenu.remove(unlinkGestureEndCmp);

				popup.add(compoundsMenu, popupCounter);
				popupCounter ++;

//				//insert option to link to previous entity, if it's in the same utterance
//				//insert option to delink if already linked to entity in different utterance
//				if (prevEntity != null && prevEntityUtterance.equals(utterance) ||
//						startCompound != null) {
				if (prevEntity != null || startCompound != null) {
					if (startCompound == null) {
						linkGestureStartCmp.setText("Link " + prevEntity.getText());
						linkGestureStartCmp.setCompound(gestEntity);
						linkGestureStartCmp.setPrevCompound(prevEntity);
						linkGestureStartCmp.setLink(true);
						compoundsMenu.add(linkGestureStartCmp);
					} else {
						// unlink previous entity, destroy compound
						unlinkGestureStartCmp
								.setText("Unlink " + prevEntity.getText());
						unlinkGestureStartCmp.setCompound(gestEntity);
						unlinkGestureStartCmp.setPrevCompound(prevEntity);
						unlinkGestureStartCmp.setLink(false);
						compoundsMenu.add(unlinkGestureStartCmp);
					}
				}
//				//insert option to link to next entity, if it's in the same utterance
//				//insert option to delink if already linked to entity in different utterance
//				if (nextEntity != null && nextEntityUtterance.equals(utterance) ||
//						endCompound != null) {
				if (nextEntity != null || endCompound != null) {
					if (endCompound == null) {
						// link following entity, create a compound
						linkGestureEndCmp.setText("Link " + nextEntity.getText());
						linkGestureEndCmp.setCompound(nextEntity);
						linkGestureEndCmp.setPrevCompound(gestEntity);
						linkGestureEndCmp.setLink(true);
						compoundsMenu.add(linkGestureEndCmp);
					} else {
						// unlink previous entity, destroy compound
						unlinkGestureEndCmp.setText("Unlink " + nextEntity.getText());
						unlinkGestureEndCmp.setCompound(nextEntity);
						unlinkGestureEndCmp.setPrevCompound(gestEntity);
						unlinkGestureEndCmp.setLink(false);
						compoundsMenu.add(unlinkGestureEndCmp);
					}
				}
			}
		}

		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);

		popup.show(panel, point.x, point.y);
		popup.setVisible(true);
		
		SS3Singleton.getSignStreamApplication().forcePopupInvisibleOnWindowLostFocus(popup);
	}
}
