package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.plaf.basic.BasicTreeUI;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.common.util.vo.Constants;
import edu.bu.signstream.common.util.vo.Palette;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.FieldWrapper;
import edu.bu.signstream.grepresentation.fields.FieldWrappersCollection;
import edu.bu.signstream.grepresentation.fields.Segment;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;

public class LabelViewGestureNRelatedFields
   extends JPanel
   implements TreeSelectionListener, KeyListener {

	private Segment segment;
	private UtteranceView view;
	private GestureNRelatedView gestureView;   
	//private SS3CodingScheme codingScheme;

   private boolean deleteNode = false;

   private JTree tree;
   boolean updating = false;

   private CustomTreeRenderer renderer;
   
   private FieldWrappersCollection fwc;

   public LabelViewGestureNRelatedFields(
      LabelObject gestureRelatedObj,
      Segment segment, UtteranceView view, GestureNRelatedView view2, FieldWrappersCollection fwc) {
      this.view = view;
      this.gestureView = view2;
      this.segment = segment;
      this.fwc = fwc;
      //this.codingScheme = view.getSignStreamSegmentPanel().getCodingScheme();

      int fontSize = 12, fontStyle = Font.PLAIN;
      String fontFamily = "Times-Roman";
      Font font = new Font(fontFamily, fontStyle, fontSize);

      renderer =
         new CustomTreeRenderer(
            Palette.AXIS_COLOR,
            200,
            SegmentGraphReprUtil.cellHeight);
      renderer.setLeafIcon(null);
      renderer.setIcon(null);
      renderer.setClosedIcon(null);
      renderer.setOpenIcon(null);
      renderer.setBackground(UIPalette.getBackground());
      renderer.setBackgroundNonSelectionColor(UIPalette.getBackground());
      renderer.setBackgroundSelectionColor(UIPalette.getBackground());
      renderer.setTextSelectionColor(Color.RED);
      renderer.setBorderSelectionColor(UIPalette.getBackground());
      renderer.setFont(font);
      

      populateTree(gestureRelatedObj);
   }
   
// // // // //     
   public void showNode(LabelObject obj) {
	   DefaultTreeModel treeModel = (DefaultTreeModel)tree.getModel();
	   DefaultMutableTreeNode fieldsRootNode = (DefaultMutableTreeNode)treeModel.getRoot();
	   
	   //
	   SS3CodingScheme dbScheme = segment.getSignStreamSegmentPanel().getSS3Database().getSS3CodingScheme();
	   dbScheme.getFieldType(obj.getFieldID());
	   //
	   
	   String type = dbScheme.getFieldType(obj.getFieldID()).getType();

	   ArrayList<LabelObject> availableObjects = new ArrayList<LabelObject>(); 	   
	   DefaultMutableTreeNode node = null;
	   int rootNodeChildCount = fieldsRootNode.getChildCount();
	   for(int counter = 0; counter < rootNodeChildCount; counter ++) {
		   DefaultMutableTreeNode pNode = (DefaultMutableTreeNode)fieldsRootNode.getChildAt(0);
		   LabelObject pObj = (LabelObject)pNode.getUserObject();
		   
		   if(type.equals(Constants.TYPE_DOM_GESTURE)) {
			   availableObjects.add(0, pObj);
		   } else if(type.equals(Constants.TYPE_NDOM_GESTURE)) {
			   availableObjects.add(1, pObj);
		   } else if(type.equals(Constants.TYPE_DOM_GESTURE_HAND)) {
			   availableObjects.add(2, pObj);
		   } else if(type.equals(Constants.TYPE_NDOM_GESTURE_HAND)) {
			   availableObjects.add(3, pObj);
		   }
		   
		   if(pObj.equals(obj)) 
			   node = pNode;
	   }
	   
	   if(!obj.isVisible()) {
		 if(node == null) {
			 return;
		 }  else {
			 fieldsRootNode.remove(node);
		 }
	   } else {
		   if(node != null)
			   fieldsRootNode.remove(node);
		   
		   DefaultMutableTreeNode newNode = createFieldNode(obj);

		   // assuming that this is the dominant field
		   int nodeIndex = 0;

		   if(type.equals(Constants.TYPE_NDOM_GESTURE) && availableObjects.get(0)!=null) {
			   nodeIndex = 1;
		   } else if(type.equals(Constants.TYPE_DOM_GESTURE_HAND)) {
			   if(availableObjects.get(0)!=null) 
				   nodeIndex++;
			   
			   if(availableObjects.get(1)!=null)
				   nodeIndex++;
		   } else if(type.equals(Constants.TYPE_NDOM_GESTURE_HAND)) {
			   if(availableObjects.get(0)!=null) 
				   nodeIndex++;
			   
			   if(availableObjects.get(1)!=null)
				   nodeIndex++;
			   
			   if(availableObjects.get(2)!=null)
				   nodeIndex++;
		   }
		   
		   treeModel.insertNodeInto(newNode, fieldsRootNode, nodeIndex);
	       treeModel.reload();
	       // ty
	   }	   
   } 
   
   private DefaultMutableTreeNode createFieldNode(LabelObject obj) {
	   DefaultMutableTreeNode node = new DefaultMutableTreeNode(obj);   
		   
	   ArrayList<LabelObject> children = obj.getChildrenAsList();
	   for(int i = 0; i < children.size(); i++) {
		   LabelObject childObj = children.get(i);
		   
		   if(childObj.isVisible()) 
			   node.add(createFieldNode(childObj));
	   }

	   return node;
   }

   public JTree getTree() {
      return tree;
   }

   public void populateTree(LabelObject object) {
      removeAll();

       Vector vector = this.populateVector(object);
       this.tree = new JTree(vector);


       BasicTreeUI ui = (BasicTreeUI) tree.getUI();
      ui.setLeftChildIndent(4);  //7
      ui.setRightChildIndent(7); //7

      // do not remove!
      tree.setCellRenderer(renderer);

      tree.setBackground(UIPalette.getBackground());
      tree.setForeground(UIPalette.getBackground());

      // setting the row height to zero makes it use the CellRenderer component's height
      // which is what we want since some rows will be taller than others
      tree.setRowHeight(0);

      tree.getSelectionModel().setSelectionMode(
         TreeSelectionModel.SINGLE_TREE_SELECTION);
      tree.addTreeSelectionListener(this);
      tree.addKeyListener(this);
      tree.addKeyListener(SS3Singleton.getVideoControlKeyListener());
      tree.setFocusable(false);

      tree.addTreeExpansionListener(new TreeExpansionListener() {
         @Override
		public void treeCollapsed(TreeExpansionEvent e) {
            loadFields();
            resizeView();
         }

         @Override
		public void treeExpanded(TreeExpansionEvent e) {
            loadFields();
            resizeView();
         }
      });

      JPanel p = new JPanel();
      p.setBackground(UIPalette.getBackground());
      p.setPreferredSize(
         new Dimension(getWidth(), SegmentGraphReprUtil.axesBottomHeight));

      setLayout(new BorderLayout());
      add(p, BorderLayout.NORTH);
      //add(new JLabel(" --- "), BorderLayout.CENTER);
      add(tree, BorderLayout.CENTER);
   }

   private void resizeView() {
      int height = tree.getPreferredSize().height;
      gestureView.setScrollPaneHeight(height);
   }

   @Override
   public void keyTyped(KeyEvent e) {}

   @Override
   public void keyPressed(KeyEvent e) {
      if (e.getKeyCode() == 8 || e.getKeyCode() == 127)
         deleteNode = true;
   }

   @Override
   public void keyReleased(KeyEvent e) {
      deleteNode = false;
   }

   /*
    * deletes node if 'DELETE' button is pressed and mouse clicked
    * */
   @Override
   public void valueChanged(TreeSelectionEvent e) {
       DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
       if (node == null) {
           updating = true;
           SS3Singleton.getMediaToolBar().deselectLabel();
           updating = false;
           return;
       }

       Object labelObject = node.getUserObject();
       if (node.getUserObject().getClass().equals(TreeNodeVector.class)) {
    	  TreeNodeVector treeNodeVector = (TreeNodeVector)labelObject;
    	  labelObject = treeNodeVector.getObject();
       }
       updating = true;
       SS3Singleton.getMediaToolBar().selectLabel((LabelObject)labelObject);
       updating = false;

      if (deleteNode) {
          if (node != null) {
              DefaultTreeModel model = (DefaultTreeModel) tree.getModel();
              model.removeNodeFromParent(node);

              int[] childIndices = new int[node.getChildCount()];
              Object[] removedChildren = new Object[node.getChildCount()];

              int i = 0;
              Enumeration enum8 = node.children();
              while (enum8.hasMoreElements()) {
                  TreeNode treeNode = (TreeNode) enum8.nextElement();
                  childIndices[i] = node.getIndex(treeNode);
                  removedChildren[i] = treeNode;
                  i++;
              }

              model.nodesWereRemoved(node, childIndices, removedChildren);
              model.nodeChanged(node);

              loadFields();
              resizeView();
              view.repaint();
          }
      }
   }

   private void loadDependentFields(JTree.DynamicUtilTreeNode node) {
      Enumeration enum7 = node.children();
      while (enum7.hasMoreElements()) {
         Object obj = enum7.nextElement();
         JTree.DynamicUtilTreeNode tNode = (JTree.DynamicUtilTreeNode) obj;
         Object userObj = tNode.getUserObject();

         TreeNode[] path = tNode.getPath();
         TreePath treePath = new TreePath(path);
         if (tree.isVisible(treePath)) {
            // add to the collection
            if (!tNode.isLeaf()) {
               TreeNodeVector vector = (TreeNodeVector) tNode.getUserObject();
               LabelObject cObj = vector.getObject();
               fwc.addFieldWrapper(cObj.getWrapper());
               loadDependentFields(tNode);
            } else {
               LabelObject cObj = (LabelObject) tNode.getUserObject();
               fwc.addFieldWrapper(cObj.getWrapper());
            }
         }
      }
   }

   private void loadFields() {
      fwc.removeAll();

      DefaultTreeModel model = (DefaultTreeModel) tree.getModel();
      DefaultMutableTreeNode node = (DefaultMutableTreeNode) model.getRoot();

      //int row = 0;
      Enumeration enum6 = node.children();
      while (enum6.hasMoreElements()) {
         Object obj = enum6.nextElement();
         JTree.DynamicUtilTreeNode tNode = (JTree.DynamicUtilTreeNode) obj;
         Object userObj = tNode.getUserObject();

         TreeNode[] path = tNode.getPath();
         TreePath treePath = new TreePath(path);
         if (tree.isVisible(treePath)) {
            // add to the collection
            if (!tNode.isLeaf()) {
               TreeNodeVector vector = (TreeNodeVector) tNode.getUserObject();
               LabelObject cObj = vector.getObject();
               fwc.addFieldWrapper(cObj.getWrapper());
               loadDependentFields(tNode);
            } else {
               LabelObject cObj = (LabelObject) tNode.getUserObject();
               fwc.addFieldWrapper(cObj.getWrapper());
            }
         }
      }

      view.repaint();
   }

   public void updateTree(LabelObject object) {
      //         segment.setLabelTreeTableObject(object);
      populateTree(object);
      resizeView();
      view.repaint();
   }

   //   private void updateTree(LabelObject obj, DefaultMutableTreeNode node) {
   //      LabelObject[] children = obj.getChildren();
   //      for (int i = 0; i < children.length; i++) {
   //         LabelObject cObj = children[i];        
   //         view.getSegment().getFieldWrappersCollection().addFieldWrapper(cObj.getWrapper());
   //         DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(cObj);
   //         cObj.setMutableTreeNode(newNode);
   //            
   //         if (cObj.isVisible()) {   
   //            node.add(newNode);
   //
   //            if (!cObj.isLeaf()) {
   //               updateTree(cObj, newNode);
   //            }
   //         }
   //      }
   //   }

   private Vector populateVector(LabelObject obj) {
      Vector node = new Vector();
      fwc.removeAll();

      if (obj == null || obj.isLeaf())
         return node;

      LabelObject[] children = obj.getChildren();
      for (int i = 0; i < children.length; i++) {
         LabelObject cObj = children[i];

         String fieldID = cObj.getFieldID();

         if (cObj.isVisible()) {
            cObj.getWrapper().setVisible(true);
            fwc.addFieldWrapper(cObj.getWrapper());
            if (cObj.isLeaf()) {
               node.add(cObj);
            } else {
               node.add(createTreeNodeVector(cObj));
            }
         }
      }
      return node;
   }
 
   private TreeNodeVector createTreeNodeVector(LabelObject obj) {
      TreeNodeVector node = new TreeNodeVector(obj);

	  SS3CodingScheme dbScheme = segment.getSignStreamSegmentPanel().getSS3Database().getSS3CodingScheme();
      String domLitTransl = dbScheme.getFieldID(Constants.TYPE_DOM_TEXT);
      String domPos = dbScheme.getFieldID(Constants.TYPE_DOM_POS_TAG);
      String nDomLitTransl =
         dbScheme.getFieldID(Constants.TYPE_NDOM_TEXT);
      String nDomPos = dbScheme.getFieldID(Constants.TYPE_NDOM_POS_TAG);

      LabelObject[] children = obj.getChildren();
      for (int i = 0; i < children.length; i++) {
         LabelObject cObj = children[i];

         String fieldID = cObj.getFieldID();

         if (cObj.isVisible()) {
            if (cObj.isLeaf()) {
               String id = cObj.getFieldID();
               if (id.equals(domLitTransl)
                  || id.equals(domPos)
                  || id.equals(nDomLitTransl)
                  || id.equals(nDomPos)) {
                  //if (cObj.getWrapper().getField().getEntities().size() > 0) {
                     node.add(cObj);
                  //}
               } else {
                  node.add(cObj);
               }
            } else {
               node.add(createTreeNodeVector(cObj));
            }
         }
      }
      return node;
   }

   private void rearageFieldWrapersNodeCollapsed(
      JTree.DynamicUtilTreeNode node,
      ArrayList list) {
      Enumeration enum5 = node.children();
      while (enum5.hasMoreElements()) {
         Object obj = enum5.nextElement();
         JTree.DynamicUtilTreeNode tNode = (JTree.DynamicUtilTreeNode) obj;
         Object userObj = tNode.getUserObject();

         FieldWrapper wrapper = null;

         if (userObj instanceof TreeNodeVector) {
            TreeNodeVector vector = (TreeNodeVector) userObj;
            LabelObject lb1 = vector.getObject();

            wrapper = fwc
                  .getFieldWrapperWithFieldID(
                  lb1.getFieldID());

            if (wrapper == null)
               return;

            wrapper.setVisible(false);

            rearageFieldWrapersNodeCollapsed(tNode, list);

         } else {
            LabelObject lb2 = (LabelObject) userObj;
            wrapper = fwc
                  .getFieldWrapperWithFieldID(
                  lb2.getFieldID());
            wrapper.setVisible(false);
         }
         list.add(wrapper);
      }
   }

   public void update() {
      tree.repaint();
      view.repaint();

   }

   public void setPreferredHeight(int ph) {
      int size = getPreferredSize().width;
      setPreferredSize(new Dimension(size, ph));
   }

   public void setPreferredWidth(int pw) {
      int size = getPreferredSize().height;
      setPreferredSize(new Dimension(pw, size));
   }
}

