package edu.bu.signstream.grepresentation.view;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

import edu.bu.signstream.common.files.SSResources;
import edu.bu.signstream.common.util.SegmentGraphReprUtil;
import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.common.util.vo.Constants;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.ui.panels.codingScheme.CSFieldDialog;

public class NonManualFieldsButtonPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private NonManualFieldsLabelView nonManualFieldsLabelView = null;
	private GlossNRelatedView glossNRelatedView;
	private GestureNRelatedView gestureNRelatedView;
	private CustomFieldsLabelView customFieldsLabelView;
	private SignStreamSegmentPanel segmentPanel = null;

	private JButton plus, minus, displayFields, displayAnnotatedFields;	//, reset;

	public NonManualFieldsButtonPanel(SignStreamSegmentPanel segmentPanel,
			NonManualFieldsLabelView nonManualFieldsLabelView, GlossNRelatedView glossNRelatedView,
			GestureNRelatedView gestureNRelatedView, CustomFieldsLabelView customFieldsLabelView) {
		this.segmentPanel = segmentPanel;
		this.nonManualFieldsLabelView = nonManualFieldsLabelView;
		this.glossNRelatedView = glossNRelatedView;
		this.gestureNRelatedView = gestureNRelatedView;
		this.customFieldsLabelView = customFieldsLabelView;

        addIcons();

		setBackground(UIPalette.getBackground());	
	}

	/**
	 * This helper method adds the plus, minus, and expand icons
	 * 
	 */
	// TODO: WTF, refactor this...
	private void addIcons() {

		setLayout(new GridBagLayout());
	    GridBagConstraints c = new GridBagConstraints();

	    c.anchor=GridBagConstraints.CENTER;
	    c.weightx=1;
	    c.gridwidth=1;

	    c.insets = new Insets(0, 10, 0, 10);
	    c.gridy = 0; 	    
	    c.gridx = 0; 
		
		ImageIcon icon;

		String plusFilePath = "plus.gif";
		icon = SSResources.icon(plusFilePath);
		if (icon != null) {
			plus = new JButton(icon);
		} else {
			plus = new JButton("+");
			System.out.println("File '" + plusFilePath + "' was not found");
		}
		AddNewFieldListener addNewFieldListener = new AddNewFieldListener(this);
		plus.addActionListener(addNewFieldListener);
		plus.setToolTipText("Display/Edit Fields");
//		setFieldsButtonsLNF(plus);

		String minusFilePath = "minus.gif";
		icon = SSResources.icon(minusFilePath);
		if (icon != null) {
			minus = new JButton(icon);
		} else {
			minus = new JButton("-");
			System.out.println("File '" + minusFilePath + "' was not found");
		}
		HideFieldListener hideFieldListener = new HideFieldListener(this);
		minus.addActionListener(hideFieldListener);
		minus.setToolTipText("Hide Selected Field");
		minus.setEnabled(false);
//		setFieldsButtonsLNF(minus);

		String displayFieldsPath = "group_purple.gif";
        icon = SSResources.icon(displayFieldsPath);
		if (icon != null) {
			displayFields = new JButton(icon);
		} else {
			displayFields = new JButton("D");
			System.out.println("File '" + displayFieldsPath + "' was not found");
		}
		displayFields.addActionListener(e -> {
            getNonManualFieldsLabelView()
                .getCSFieldDialog()
                .getCSFieldPanel()
                .refreshVisibleFields();
        });
		displayFields.setToolTipText("Refresh Default Display");
//		setFieldsButtonsLNF(displayFields);

		var displayAnnotatedFieldsPath = "group.gif";
        icon = SSResources.icon(displayAnnotatedFieldsPath);
        if (icon != null) {
            displayAnnotatedFields = new JButton(icon);
        } else {
            displayAnnotatedFields = new JButton("DA");
            System.out.println("File '" + displayAnnotatedFieldsPath + "' was not found");
        }
        displayAnnotatedFields.addActionListener(e -> {
            getNonManualFieldsLabelView()
                .getCSFieldDialog()
                .getCSFieldPanel()
                .refreshVisibleAnnotatedFields();
        });
        displayAnnotatedFields.setToolTipText("Display Non-empty");
//        setFieldsButtonsLNF(displayAnnotatedFields);

//		String resetFilePath = "reset.gif";
//		icon = SS3Resources.icon(resetFilePath);
//		if (icon != null) {
//			reset = new JButton(icon);
//		} else {
//			reset = new JButton("R");
//			System.out.println("File '" + resetFilePath + "' was not found");
//		}
//		ResetFieldOrderListener resetListener = new ResetFieldOrderListener(nonManualFieldsLabelView, customFieldsLabelView, segmentPanel);
//		reset.addActionListener(resetListener);
//		reset.setToolTipText("Reset Field Order");
//		setFieldsButtonsLNF(reset);

		add(plus, c);
		c.gridx++;
		add(minus, c);
		c.gridx++;
		add(displayFields, c);
		c.gridx++;
		add(displayAnnotatedFields, c);
//		add(reset);
	}

	public void setHideEnabled(boolean enabled) {
	    minus.setEnabled(enabled);
    }

	private static void setFieldsButtonsLNF(JButton btn, int fontSize) {
		Font btnFont = new Font(btn.getFont().getName(), Font.PLAIN, fontSize);
		FontMetrics btnFontMetrics = btn.getFontMetrics(btnFont);
		int addBtnHeight = btnFontMetrics.getHeight();
		int addBtnWidth = btnFontMetrics.stringWidth(btn.getText());

		btn.setFont(btnFont);

		Dimension addBtnMinSize = new Dimension(addBtnWidth + 15, addBtnHeight);
		btn.setMaximumSize(addBtnMinSize);
		btn.setPreferredSize(addBtnMinSize);
		btn.setMaximumSize(addBtnMinSize);
	}
    private static void setFieldsButtonsLNF(JButton btn) { setFieldsButtonsLNF(btn, 8); }

	public NonManualFieldsLabelView getNonManualFieldsLabelView() {
		return nonManualFieldsLabelView;
	}

	public GlossNRelatedView getGlossNRelatedView() {
		return glossNRelatedView;
	}
	
	public GestureNRelatedView getGestureNRelatedView() {
		return gestureNRelatedView;
	}
	
	public CustomFieldsLabelView getCustomFieldsLabelView() {
		return customFieldsLabelView;
	}

	public SignStreamSegmentPanel getSignStreamSegmentPanel() {
		return segmentPanel;
	}
}

class AddNewFieldListener implements ActionListener {

	private NonManualFieldsButtonPanel buttonPanel = null;
	private CSFieldDialog csFieldDialog = null;

	public AddNewFieldListener(NonManualFieldsButtonPanel parent) {
		this.buttonPanel = parent;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		LabelObject selectedFieldLabel = SS3Singleton.getMediaToolBar().selectedLabel();

		String fieldID = null;

		if (selectedFieldLabel != null)
			fieldID = selectedFieldLabel.getFieldID();

		if (csFieldDialog == null)
			csFieldDialog = (CSFieldDialog) buttonPanel.getNonManualFieldsLabelView().getCSFieldDialog();

		csFieldDialog.setVisible(true, fieldID);
	}
}

class HideFieldListener implements ActionListener {
	private NonManualFieldsButtonPanel buttonPanel = null;
	private CSFieldDialog csFieldDialog = null;

	public HideFieldListener(NonManualFieldsButtonPanel parent) {
		this.buttonPanel = parent;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
	    var selectedFieldLabel = SS3Singleton.getMediaToolBar().selectedLabel();
	    if (selectedFieldLabel == null)
	        return;

		String fieldID = selectedFieldLabel.getFieldID();
		if (Constants.isStaticField(fieldID))
		    return;

		selectedFieldLabel.setVisible(false);
		selectedFieldLabel.getWrapper().setVisible(false);
		selectedFieldLabel.getWrapper().setSelectedNHighlighted(false);

		if (csFieldDialog == null)
			csFieldDialog = buttonPanel.getNonManualFieldsLabelView().getCSFieldDialog();

		// pass in false and set that field to unchecked, and the enter will hide it
		// from view
        csFieldDialog.setSelectedField(fieldID, false);
		csFieldDialog.getCSFieldPanel().redraw();
	}

}

class ResetFieldOrderListener implements ActionListener {

	private NonManualFieldsLabelView nonmanualFieldsLabelView;
	private CustomFieldsLabelView customFieldsLabelView;
	private SignStreamSegmentPanel segmentPanel;

	public ResetFieldOrderListener(NonManualFieldsLabelView lblView, 
			CustomFieldsLabelView customFieldsLabelView,
			SignStreamSegmentPanel segmentPanel) {
		this.nonmanualFieldsLabelView = lblView;
		this.customFieldsLabelView = customFieldsLabelView;
		this.segmentPanel = segmentPanel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
//		segmentPanel.getSS3Database().setDBFieldOrder(null);
		nonmanualFieldsLabelView.updateLabelOrder();
		customFieldsLabelView.updateLabelOrder();
	}
}
