package edu.bu.signstream.grepresentation.view;

public class ViewData {
    private String panelID;
    private double panelPercentage;
    private int order;

    // Constructors with default values as needed... All three values should be set, however.

    public ViewData() {
        this.order = -1;
        this.panelID = "-1";
        this.panelPercentage = -1.0;
    }

    public ViewData(int order) {
        this.order = order;
        this.panelID = "-1";
        this.panelPercentage = -1.0;
    }

    public ViewData(String panelID, int order) {
        this.order = order;
        this.panelID = panelID;
        this.panelPercentage = -1.0;
    }

    public ViewData(String panelID, int order, double panelPercentage) {
        this.order = order;
        this.panelID = panelID;
        this.panelPercentage = panelPercentage;
    }

    public int getOrder() {
        return this.order;
    }

    public void setOrder(int order) {
        this.order = order;
    }

    public double getPanelPercentage() {
        return this.panelPercentage;
    }

    public void setPanelPercentage(double panelPercentage) {
        this.panelPercentage = panelPercentage;
    }

    public void setPanelID(String panelID) {
        this.panelID = panelID;
    }

    public String getPanelID() {
        return this.panelID;
    }

    @Override
    public String toString() {
        return String.format("PANEL_ID=%s PANEL_RATIO=%f ORDER=%d", this.panelID, this.panelPercentage, this.order);
    }
}
