package edu.bu.signstream.grepresentation.view.signbank;

import java.util.ArrayList;

public class SignBankOccurrence {
	
	private String occurrenceID = null;
	
	private boolean globalOccurrence = false;
	
	private String sourceSignBankResourceFileName = null;
	
	private SignBankVariant parentVariant = null;

	private String domStartHS;
	private String nondomStartHS;
	private String domEndHS;
	private String nondomEndHS;
	private String participant;
	private String signType;
	private String twoHanded;
	private String passiveBaseArm;
	private String markedHands;
	private String leftRightHS;
	private String startEndHS;
	private String startEndLeftHS;
	private String startEndRightHS;	
	
	private String endImageURL;
	private String startImageURL;
	private ArrayList<String> frameImageURLs = new ArrayList<String>();
	private ArrayList<String> signVideoURLs = new ArrayList<String>();
	private ArrayList<String> utteranceVideoURLs = new ArrayList<String>();
	
	public SignBankOccurrence(SignBankVariant parentVariant, String occurrenceID) {
		this.parentVariant = parentVariant;
		this.occurrenceID = occurrenceID;
	}
	
	public String getOccurrenceID() {
		return occurrenceID;
	}

	public String getSignBankResourceFileName() {
		return sourceSignBankResourceFileName;
	}
	
	public void setSignBankResourceFileName(String resourceFileName) {
		this.sourceSignBankResourceFileName = resourceFileName;
	}
	
	public SignBankVariant getParentVariant() {
		return parentVariant;
	}

	public String getDomStartHS() {
		return domStartHS;
	}
	public void setDomStartHS(String domStartHS) {
		this.domStartHS = domStartHS;
	}
	public String getNondomStartHS() {
		return nondomStartHS;
	}
	public void setNondomStartHS(String nondomStartHS) {
		this.nondomStartHS = nondomStartHS;
	}
	public String getDomEndHS() {
		return domEndHS;
	}
	public void setDomEndHS(String domEndHS) {
		this.domEndHS = domEndHS;
	}
	public String getNondomEndHS() {
		return nondomEndHS;
	}
	public void setNondomEndHS(String nondomEndHS) {
		this.nondomEndHS = nondomEndHS;
	}
	public String getParticipant() {
		return participant;
	}
	public void setParticipant(String participant) {
		this.participant = participant;
	}
	public String getSignType() {
		return signType;
	}
	public void setSignType(String signType) {
		this.signType = signType;
	}
	public String getTwoHanded() {
		return twoHanded;
	}
	public void setTwoHanded(String twoHanded) {
		this.twoHanded = twoHanded;
	}
	public boolean isTwoHanded() {
		if (twoHanded == null || twoHanded.isEmpty())
			return false;
		else
			return twoHanded.equals("T");
	}
	public String getPassiveBaseArm() {
		return passiveBaseArm;
	}
	public void setPassiveBaseArm(String passiveBaseArm) {
		this.passiveBaseArm = passiveBaseArm;
	}
	public boolean isPassiveBaseArm() {
		if (passiveBaseArm == null || passiveBaseArm.isEmpty())
			return false;
		else
			return passiveBaseArm.equals("T");
	}
	public String getMarkedHands() {
		return markedHands;
	}
	public void setMarkedHands(String markedHands) {
		this.markedHands = markedHands;
	}
	public boolean isMarkedHands() {
		if (markedHands == null || markedHands.isEmpty())
			return false;
		else
			return markedHands.equals("T");
	}
	public String getLeftRightHS() {
		return leftRightHS;
	}
	public void setLeftRightHS(String leftRightHS) {
		this.leftRightHS = leftRightHS;
	}
	public String getStartEndHS() {
		return startEndHS;
	}
	public void setStartEndHS(String startEndHS) {
		this.startEndHS = startEndHS;
	}
	public String getStartEndLeftHS() {
		return startEndLeftHS;
	}
	public void setStartEndLeftHS(String startEndLeftHS) {
		this.startEndLeftHS = startEndLeftHS;
	}
	public String getStartEndRightHS() {
		return startEndRightHS;
	}
	public void setStartEndRightHS(String startEndRightHS) {
		this.startEndRightHS = startEndRightHS;
	}
	public ArrayList<String> getFrameImageURLs() {
		return frameImageURLs;
	}
	public void addFrameImageURL(String frameImageURL) {
		frameImageURLs.add(frameImageURL);
	}
	public void removeFrameImageURL(/*what here?*/) {
//		frameImageURLs.remove(0);
	}
	public ArrayList<String> getSignVideoURLs() {
		return signVideoURLs;
	}
	public void addSignVideoURL(String signVideoURL) {
		signVideoURLs.add(signVideoURL);
	}
	public void removeSignVideoURL(/*what here?*/) {
//		signVideoURLs.remove(0);
	}
	public ArrayList<String> getUtteranceVideoURLs() {
		return utteranceVideoURLs;
	}
	public void addUtteranceVideoURL(String signVideoURL) {
		utteranceVideoURLs.add(signVideoURL);
	}
	public void removeUtteranceVideoURL(/*what here?*/) {
//		utteranceVideoURLs.remove(0);
	}
	public void addStartImageURL(String url) {
		startImageURL = url;
	}
	public void addEndImageURL(String url) {
		endImageURL = url;
	}
	public String getStartImageURL() {
		return startImageURL;
	}
	public String getEndImageURL() {
		return endImageURL;
	}
	
	@Override
	public String toString() {
		
		String ret = "SignBankOccurrence[";
		ret += "Occurrence ID=" + occurrenceID;
		ret += ", Global Occurrence=" + globalOccurrence;
		ret += ", Source Resource=" + sourceSignBankResourceFileName;
		ret += ", DomStartHS=" + getDomStartHS();
		ret += ", DomEndHS=" + getDomEndHS();
		ret += ", NondomStartHS=" + getNondomStartHS();
		ret += ", NondomEndHS=" + getNondomEndHS();
		ret += ", Images=" + getFrameImageURLs();
		ret += ", Start Image=" + getStartImageURL();
		ret += ", End Image=" + getEndImageURL();
		ret += ", SignVideos=" + getSignVideoURLs();
		ret += ", UtteranceVideos=" + getUtteranceVideoURLs();
		ret += ", Participant=" + getParticipant();
		ret += ", SignType=" + getSignType();
		ret += ", TwoHanded=" + getTwoHanded();
		ret += ", PassiveBaseArm=" + getPassiveBaseArm();
		ret += ", MarkedHands=" + getMarkedHands();
		ret += ", LeftRightHS=" + getLeftRightHS();
		ret += ", StartEndHS=" + getStartEndHS();
		ret += ", StartEndRightHS=" + getStartEndRightHS();
		ret += ", StartEndLeftHS=" + getStartEndLeftHS();
		ret += "]";
		
		return ret;
	}
}