package edu.bu.signstream.media.ui.color;

import edu.bu.signstream.common.SSMath;

import java.awt.*;

public class Gradient implements ColorMap {
    private final Color c0;
    private final Color c1;

    public Gradient(Color c0, Color c1) {
        this.c0 = c0;
        this.c1 = c1;
    }

    public static Gradient of(Color c0, Color c1) {
        return new Gradient(c0, c1);
    }

    @Override
    public Color map(double fr) {
        var r = (int)Math.round(SSMath.lerp(c0.getRed(),   c1.getRed(),   fr));
        var g = (int)Math.round(SSMath.lerp(c0.getGreen(), c1.getGreen(), fr));
        var b = (int)Math.round(SSMath.lerp(c0.getBlue(),  c1.getBlue(),  fr));
        var a = (int)Math.round(SSMath.lerp(c0.getAlpha(), c1.getAlpha(), fr));
        return new Color(r, g, b, a);
    }
}
