package edu.bu.signstream.ui.panels;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;
import javax.swing.WindowConstants;

import edu.bu.signstream.common.util.vo.ss3.participants.SS3Participant;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.ui.panels.newDatabase.ParticipantView;
import edu.bu.signstream.ui.panels.newDatabase.ParticipantsPaneScrolledView;

public class AnnotatorsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private AnnotatorsPanel annotatorsPanel = null;

	public AnnotatorsDialog(SS3Participant selectedParticipant,
			ParticipantsPaneScrolledView participantsPaneScrolledView,
			ParticipantView participantView) {
		super(SS3Singleton.getSignStreamApplication(), true);
		
		String title = "";
		if(participantsPaneScrolledView != null) {
			if(participantsPaneScrolledView.isParticipant()) {
				title = title + "Participant Selection";
			} else {
				title = title + "Annotator Selection";
			}
		} else if(participantView != null) {			
			if(participantView.isParticipant()) {
				title = title + "Participant Selection";
			} else {
				title = title + "Annotator Selection";
			}
		}
		
		setTitle(title);

		annotatorsPanel = new AnnotatorsPanel(selectedParticipant, participantsPaneScrolledView, participantView, this);

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
				annotatorsPanel.cancelEntry();
			}
		});
		
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(50, 50));
		contentPane.add(annotatorsPanel, BorderLayout.CENTER);
		this.pack();
	}
	
	public AnnotatorsPanel getAnnotatorsPanel() {
		return annotatorsPanel;
	}
}
