package edu.bu.signstream.ui.panels.newDatabase;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragGestureRecognizer;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.DropMode;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.TransferHandler;

import edu.bu.signstream.common.util.signbank.SignBankResource;
import edu.bu.signstream.common.util.signbank.SignBankResourceCollection;

/**
 * Currently in progress
 */
public class SignBankResourceCollectionView extends JPanel implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	private SignBankResourceCollection resourceCollection = null;
	
	private JPanel titlePanel = null;
	
	private JLabel label = null;
	private JButton addNewFileButton = null;
	
	private SignBankResourceList resourceList = null;
	private JScrollPane scroller = null;
	
	private final int SELECT_ROW = 10;
	private final int ADD_ROW = 20;

	/**
	 * Currently in progress
	 */
	public SignBankResourceCollectionView(SignBankResourceCollection resourceCollection) {
		this.resourceCollection = resourceCollection;

		titlePanel = new JPanel(new GridLayout(1, 0));
		titlePanel.setFocusable(true);
		
		label = new JLabel("Sign Bank Files");
		
		addNewFileButton = new JButton("Add");
		addNewFileButton.addActionListener(this);
		addNewFileButton.setActionCommand("" + ADD_ROW);
		
		titlePanel.add(label);
		titlePanel.add(addNewFileButton);
		
		resourceList = new SignBankResourceList();
		
		// add each sign bank resource to its own box with up/down arrows for reordering
		ArrayList<SignBankResource> resourcesList = resourceCollection.getResourcesList();
		for (SignBankResource resource: resourcesList) {
			resourceList.addResource(resource);
		}
		
		scroller = new JScrollPane(resourceList);
		scroller.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		
		setBackground(Color.WHITE);
		add(titlePanel, BorderLayout.PAGE_START);
		add(scroller, BorderLayout.CENTER);
	}
	
	public void update(SignBankResourceCollection resourceCollection) {
		this.resourceCollection = resourceCollection;
	}
	
	public SignBankResourceCollection getCurrentState() {
		ArrayList<SignBankResource> resourcesList = new ArrayList<SignBankResource>();
		/*
		 * loop through panel list as it currently is
		 * for each one, get the resource and add it to the array
		 * call resourceCollection.setlist(array);
		 * return collection
		 */
		
		return null;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		String str = e.getActionCommand();

		switch (Integer.parseInt(str)) {
		case SELECT_ROW:
			break;
			
		case ADD_ROW:
			break;

		}
		
	}
	
	private class SignBankResourceList extends JList<String> {
		private static final long serialVersionUID = 1L;
		
		private DefaultListModel<String> model = null;
		private ArrayList<SignBankResource> resourcesList;
		
		public SignBankResourceList() {
		    super(new DefaultListModel<String>());
		    model = (DefaultListModel<String>) getModel();
		    setDragEnabled(true);
		    setDropMode(DropMode.INSERT);

		    setTransferHandler(new MyListDropHandler(this));

		    new MyDragListener(this);

			resourcesList = new ArrayList<SignBankResource>();
		}
		
		public void addResource(SignBankResource resource) {
			model.addElement(resource.getSignBankFileName());
			resourcesList.add(resource);
		}
		
	}

	private class MyDragListener implements DragSourceListener, DragGestureListener {
		SignBankResourceList list;

		DragSource ds = new DragSource();

		public MyDragListener(SignBankResourceList list) {
			this.list = list;
			DragGestureRecognizer dgr = ds.createDefaultDragGestureRecognizer(list,
					DnDConstants.ACTION_MOVE, this);

		}

		@Override
		public void dragGestureRecognized(DragGestureEvent dge) {
			StringSelection transferable = new StringSelection(Integer.toString(list.getSelectedIndex()));
			ds.startDrag(dge, DragSource.DefaultCopyDrop, transferable, this);
		}

		@Override
		public void dragEnter(DragSourceDragEvent dsde) {
		}

		@Override
		public void dragExit(DragSourceEvent dse) {
		}

		@Override
		public void dragOver(DragSourceDragEvent dsde) {
		}

		@Override
		public void dragDropEnd(DragSourceDropEvent dsde) {
			if (dsde.getDropSuccess()) {
				System.out.println("Succeeded");
			} else {
				System.out.println("Failed");
			}
			
			list.revalidate();
			list.repaint();
		}

		@Override
		public void dropActionChanged(DragSourceDragEvent dsde) {
		}
	}

	private class MyListDropHandler extends TransferHandler {
		SignBankResourceList list;

		public MyListDropHandler(SignBankResourceList list) {
			this.list = list;
		}

		@Override
		public boolean canImport(TransferHandler.TransferSupport support) {
			if (!support.isDataFlavorSupported(DataFlavor.stringFlavor)) {
				return false;
			}
			JList.DropLocation dl = (JList.DropLocation) support.getDropLocation();
			if (dl.getIndex() == -1) {
				return false;
			} else {
				return true;
			}
		}

		@Override
		public boolean importData(TransferHandler.TransferSupport support) {
			if (!canImport(support)) {
				return false;
			}

			Transferable transferable = support.getTransferable();
			String indexString;
			try {
				indexString = (String) transferable.getTransferData(DataFlavor.stringFlavor);
			} catch (Exception e) {
				return false;
			}

			int index = Integer.parseInt(indexString);
			JList.DropLocation dl = (JList.DropLocation) support.getDropLocation();
			int dropTargetIndex = dl.getIndex();

			System.out.println(dropTargetIndex + " : ");
			System.out.println("inserted");
			return true;
		}
	}
	
	// http://www.java2s.com/Tutorial/Java/0240__Swing/Usedraganddroptoreorderalist.htm

}
