package edu.bu.signstream.ui.panels.search;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.HeadlessException;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class SearchDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private SearchPanel searchPanel = null;
	
	public SearchDialog(SS3SignStreamApplication application) {
		super(SS3Singleton.getSignStreamApplication(), "Search Window");
		
		searchPanel = new SearchPanel(application);

		// change sizes, layouts, etc
		setResizable(true);

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());
		contentPane.add(searchPanel, BorderLayout.CENTER);
		
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				searchPanel = null;
				dispose();
			}
		});
		
		this.pack();	
	}
	
	public SearchPanel getSearchPanel() {
		return searchPanel;
	}
}
